#include "stdafx.h"
#include "Global.h"
#include <SetupAPI.h>
#include <InitGuid.h>
#include <WinIoCtl.h>
#include <direct.h>
#include <fcntl.h>
#include <share.h>
#include <sys\stat.h>
#pragma comment(lib, "SetupAPI.lib")

namespace Global
{
	//////////////////////////////////////////////////////////////////////////
	// ȫֱ;
	TCHAR g_szCurModuleDir[MAX_PATH] = { 0 };
	TCHAR g_szCurModulePath[MAX_PATH] = { 0 };
	TCHAR g_szFna[MAX_PATH] = { 0 };
	TCHAR g_szConfig[MAX_PATH] = { 0 };
	TCHAR g_szLogPath[MAX_PATH] = { 0 };
	TCHAR g_szPython27Dir[MAX_PATH] = {0};
	TCHAR g_szTVPort[MAX_PATH] = {0};
	TCHAR g_szTVReboot[MAX_PATH] = {0};
	TCHAR g_szTVShutdown[MAX_PATH] = {0};
	BOOL  g_bWatchTVPort = FALSE;

	bool g_bEnableLog = false;
	COleDateTime g_lastTime;
	time_t g_time = time(NULL);
	ThreadSection g_critSection;
	FILE *gp_log_fp = NULL;
	
	//////////////////////////////////////////////////////////////////////////
	bool MKDIR(LPCTSTR dir) 
	{
		//////////////////////////////////////////////////////////////////////////
		// Ŀ¼;
		int nleft = 0;
		int nIndex = -1;
		string strdir = dir;
		strdir = strdir.substr(0, strdir.find_last_of(_T("\\")));

		if (strdir.at(strdir.size() - 1) != _T('\\'))
			strdir.append(_T("\\"));

		// ·Ӳ̷;
		if (_tcscmp(strdir.substr(0, 2).c_str(), _T("\\\\")) == 0)
			nleft = strdir.find_first_of(_T("\\"), 2) + 1;	// ȥ;
		else if (strdir.at(2) == _T('\\'))
			nleft = 3;

		do
		{
			nIndex = strdir.substr(nleft, -1).find_first_of(_T("\\"));

			if (nIndex != string::npos)
			{
				if (_mkdir(strdir.substr(0, nIndex + nleft).c_str()) == -1 && (errno != EEXIST))
				{
					WriteTextLog(_T("Ŀ¼ʧܣ%s룺%d"), strdir.substr(0, nIndex + nleft).c_str(), errno);
					return false;
				}

				nleft += nIndex + 1;
			}
		} while (nIndex != -1);

		return true;
	};

	// ȫֺ;
	/************************************************************************/
	/*  WriteTextLog[7/28/2009 Jeff];
	/*  дı־;
	/*  ;
	/*  	[IN] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void WriteTextLog(const TCHAR* format, ...)
	{
		static ThreadSection _critSection;
		AutoThreadSection aSection(&_critSection);
		// ־뵽ļ;
		// ȡ;
		__time64_t gmt = time(NULL); // ȡǰʱ(1900-01-01ʼUnixʱ);
		struct tm gmtm = { 0 };
		localtime_s(&gmtm, &gmt); // ʱתɱʱ;

		// ־·;
		TCHAR szlogpath[MAX_PATH] = { 0 };
		_stprintf_s(szlogpath, _T("%srunner-log %02d%02d.txt"), g_szCurModuleDir, gmtm.tm_mon + 1, gmtm.tm_mday);
		// 򿪻򴴽ļ;
		FILE* fp = NULL;
		//MKDIR(g_szLogPath);
		//if (_taccess(szlogpath, 0) != -1)
#ifndef UNICODE
		if (_access(szlogpath, 0) != -1)
#else
		if (_taccess(szlogpath, 0) != -1)
#endif
		{ // ;
			if (0 == _tfopen_s(&fp, szlogpath, _T("a+")))
				// ƶĩβ;
				fseek(fp, 0, SEEK_END);
		}
		else
		{ // ;
			_tfopen_s(&fp, szlogpath, _T("w+"));
		}

		if (fp == NULL)
			return;

		// ʽǰ;
		TCHAR* old_locale = _tcsdup(_tsetlocale(LC_CTYPE, NULL));
		_tsetlocale(LC_CTYPE, _T("chs")); //趨;

		// ʽ־;
		va_list args = NULL;
		int len = 0;
		TCHAR* buffer = NULL;
		va_start(args, format);
		// _vscprintf doesn't count. terminating '\0'
		len = _vsctprintf(format, args) + 1;
		buffer = (TCHAR*)malloc(len * sizeof(TCHAR));
		_vstprintf_s(buffer, len, format, args);
		_ftprintf(fp, _T("%04d-%02d-%02d %02d:%02d:%02d %s\n"), gmtm.tm_year + 1990, gmtm.tm_mon + 1, gmtm.tm_mday, gmtm.tm_hour, gmtm.tm_min, gmtm.tm_sec, buffer);

		// رļͷԴûԭ;
		free(buffer);
		fclose(fp);
		_tsetlocale(LC_CTYPE, old_locale);
		free(old_locale); //ԭ趨;
	}

	void WritePythonLog(LPCTSTR file, const TCHAR* msg)
	{
		AutoThreadSection aSection(&g_critSection);
		// ־뵽ļ;
		// ȡ;
		//__time64_t gmt = time(NULL); // ȡǰʱ(1900-01-01ʼUnixʱ);
		//struct tm gmtm = { 0 };
		//localtime_s(&gmtm, &gmt); // ʱתɱʱ;

		int nErr = -1;
		// 򿪻򴴽ļ;
		FILE* fp = NULL;
		
#ifndef UNICODE
		if (_access(file, 0) != -1)
#else
		if (_taccess(file, 0) != -1)
#endif
		{ // ;
			if (0 == _tfopen_s(&fp, file, _T("a+")))
			{
				// ƶĩβ;
				fseek(fp, 0, SEEK_END);
			}
			else
			{
				WriteTextLog(_T("ļʧܣ%s,%d"), file, GetLastError());
				return;
			}
		}
		else
		{ // ;
			MKDIR(file);
			if (0 !=  _tfopen_s(&fp, file, _T("w+")) )
			{
				WriteTextLog(_T("ļʧܣ%s,%d"), file, GetLastError());
				return;
			}
		}

		if (fp == NULL)
		{
			WriteTextLog(_T("ļգ%s,%d"), file, GetLastError());
			return;
		}

		// ʽǰ;
		TCHAR* old_locale = _tcsdup(_tsetlocale(LC_CTYPE, NULL));
		_tsetlocale(LC_CTYPE, _T("chs")); //趨;
		//_ftprintf(fp, _T("%04d-%02d-%02d %02d:%02d:%02d %s\n"), gmtm.tm_year + 1990, gmtm.tm_mon + 1, gmtm.tm_mday, gmtm.tm_hour, gmtm.tm_min, gmtm.tm_sec, msg);
		_ftprintf(fp, _T("%s"), msg);
		// رļͷԴûԭ;
		fclose(fp);
		_tsetlocale(LC_CTYPE, old_locale);
		free(old_locale); //ԭ趨;
	}

	// עȡ Python27·;
	BOOL Python27Dir(LPTSTR lpPython27Dir, int nBufferLen)
	{
		HKEY hKey;
		int ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\WOW6432Node\\Python\\PythonCore\\2.7\\InstallPath"), 0, KEY_QUERY_VALUE, &hKey);
		if (ret != ERROR_SUCCESS)
			return FALSE;

		//ȡKEY
		DWORD dwType = REG_SZ; //
		DWORD cbData = nBufferLen;
		ret = RegQueryValueEx(hKey, _T(""), NULL, &dwType, (LPBYTE)lpPython27Dir, &cbData);
		if (ret != ERROR_SUCCESS)
		{
			RegCloseKey(hKey);
			return FALSE;
		}
		RegCloseKey(hKey);

		return TRUE;
	}

	void ClosePythonLog()
	{
		AutoThreadSection aSection(&g_critSection);
		if ( gp_log_fp )
		{
			WriteTextLog(_T("رļ%s"), g_szLogPath);
			fclose(gp_log_fp);
			gp_log_fp = NULL;
		}
	}

	// ȥո;
	std::string& trim(std::string& str)
	{
		int nIndex = 0;
		while ((nIndex = str.find_first_of(' ')) != std::string::npos)
			str.erase(nIndex, 1);

		return str;
	}

	// hModule ģ NULLʾǰģ;
	bool GetVersion(IN const TCHAR* fname, OUT WORD* pdwFileVersion, OUT WORD* pdwProductVerion)
	{
		VS_FIXEDFILEINFO* pVi = NULL;
		DWORD dwHandle = 0;
		int size = GetFileVersionInfoSize(fname, &dwHandle);
		if (size > 0)
		{
			BYTE* buffer = new BYTE[size];
			memset(buffer, 0, size);

			if (GetFileVersionInfo(fname, 0, size, buffer))
			{
				if (VerQueryValue(buffer, _T("\\"), (LPVOID*)& pVi, (PUINT)& size))
				{
					pdwFileVersion[0] = HIWORD(pVi->dwFileVersionMS);
					pdwFileVersion[1] = LOWORD(pVi->dwFileVersionMS);
					pdwFileVersion[2] = HIWORD(pVi->dwFileVersionLS);
					pdwFileVersion[3] = LOWORD(pVi->dwFileVersionLS);

					pdwProductVerion[0] = HIWORD(pVi->dwProductVersionMS);
					pdwProductVerion[1] = LOWORD(pVi->dwProductVersionMS);
					pdwProductVerion[2] = HIWORD(pVi->dwProductVersionLS);
					pdwProductVerion[3] = LOWORD(pVi->dwProductVersionLS);

					delete[] buffer;
					return true;
				}
			}

			delete[] buffer;
		}

		return false;
	}

	BOOL GetVersion(IN HMODULE hModule, OUT DWORD(&dwFVArray)[4], OUT DWORD(&dwPVArray)[4])
	{
		TCHAR fname[MAX_PATH];
		VS_FIXEDFILEINFO* pVi;
		DWORD dwHandle;

		if (GetModuleFileName(hModule, fname, MAX_PATH))
		{
			INT nSize = GetFileVersionInfoSize(fname, &dwHandle);

			if (nSize > 0)
			{
				BYTE* pBuffer = new BYTE[nSize];
				memset(pBuffer, 0, nSize);

				if (GetFileVersionInfo(fname, 0, nSize, pBuffer))
				{
					if (VerQueryValue(pBuffer, _T("\\"), (LPVOID*)& pVi, (PUINT)& nSize))
					{
						dwFVArray[0] = HIWORD(pVi->dwFileVersionMS);
						dwFVArray[1] = LOWORD(pVi->dwFileVersionMS);
						dwFVArray[2] = HIWORD(pVi->dwFileVersionLS);
						dwFVArray[3] = LOWORD(pVi->dwFileVersionLS);

						dwPVArray[0] = HIWORD(pVi->dwProductVersionMS);
						dwPVArray[1] = LOWORD(pVi->dwProductVersionMS);
						dwPVArray[2] = HIWORD(pVi->dwProductVersionLS);
						dwPVArray[3] = LOWORD(pVi->dwProductVersionLS);

						delete[]pBuffer;
						return TRUE;
					}
				}

				if (pBuffer)
					delete[]pBuffer;
			}
		}

		return FALSE;
	}

	WCHAR* ASCII2UNICODE(IN LPCCH lpASCIIStr)
	{
		if (lpASCIIStr == NULL)
			return NULL;

		// ȡַֽ;
		int cchWideChar = MultiByteToWideChar(CP_ACP, 0, lpASCIIStr, -1, NULL, 0);
		if (cchWideChar == 0)
			return NULL;

		// תɿַ;
		WCHAR* pWideChar = new WCHAR[cchWideChar + 1];
		memset(pWideChar, 0, sizeof(WCHAR) * (cchWideChar + 1));
		int nWriteNum = MultiByteToWideChar(CP_ACP, 0, lpASCIIStr, -1, pWideChar, cchWideChar);
		if (nWriteNum != cchWideChar)
		{
			if (pWideChar)
				delete[] pWideChar;
			return NULL;
		}

		return pWideChar;
	}

	BOOL UNICODE2UTF8(IN LPWCH lpUNICODEStr, OUT string& strResult)
	{
		if (lpUNICODEStr == NULL)
			return FALSE;

		// ȡַֽֽ;
		int cbMultiByte = WideCharToMultiByte(CP_UTF8, 0, lpUNICODEStr, -1, NULL, 0, NULL, NULL);
		if (cbMultiByte == 0)
			return FALSE;

		// תɶַֽ;
		CHAR* pResult = new CHAR[cbMultiByte];
		memset(pResult, 0, cbMultiByte);
		int nWriteNum = WideCharToMultiByte(CP_UTF8, 0, lpUNICODEStr, -1, pResult, cbMultiByte, NULL, NULL);
		if (nWriteNum != cbMultiByte)
			return FALSE;

		strResult = pResult;
		if (pResult)
			delete[] pResult;

		return TRUE;
	}

	BOOL ASCII2UTF8(IN LPCCH lpASCIIStr, OUT string& strResult)
	{
		// ASCIIַתUNICODEַ;
		WCHAR* pWideChar = ASCII2UNICODE(lpASCIIStr);
		if (pWideChar == NULL)
			return FALSE;

		// ٽUICODEתUTF8;
		BOOL bResult = UNICODE2UTF8(pWideChar, strResult);

		if (pWideChar)
			delete[] pWideChar;

		return bResult;
	}

	string EnCode_UTF8URL(IN const CHAR* pText)
	{
		string tt = "";
		string dd = "";
		ASCII2UTF8(pText, tt);

		size_t len = tt.length();
		for (size_t i = 0; i < len; i++)
		{
			if (isalnum((BYTE)tt.at(i)))
			{
				char tempbuff[2] = { 0 };
				sprintf_s(tempbuff, "%c", (BYTE)tt.at(i));
				dd.append(tempbuff);
			}
			else if (isspace((BYTE)tt.at(i)))
			{
				dd.append("+");
			}
			else
			{
				char tempbuff[4];
				sprintf_s(tempbuff, "%%%X%X", ((BYTE)tt.at(i)) >> 4, ((BYTE)tt.at(i)) % 16);
				dd.append(tempbuff);
			}
		}
		return dd;
	}

	void EnCode_UTF8URL(IN const CHAR* pText, OUT string& strResult)
	{
		string tt = "";
		ASCII2UTF8(pText, tt);

		size_t len = tt.length();
		for (size_t i = 0; i < len; i++)
		{
			if (isalnum((BYTE)tt.at(i)))
			{
				char tempbuff[2] = { 0 };
				sprintf_s(tempbuff, "%c", (BYTE)tt.at(i));
				strResult.append(tempbuff);
			}
			else if (isspace((BYTE)tt.at(i)))
			{
				strResult.append("+");
			}
			else
			{
				char tempbuff[4];
				sprintf_s(tempbuff, "%%%X%X", ((BYTE)tt.at(i)) >> 4, ((BYTE)tt.at(i)) % 16);
				strResult.append(tempbuff);
			}
		}
	}

	//ΪUrlʹ
	char CharToInt(char ch)
	{
		if (ch >= '0' && ch <= '9')return (char)(ch - '0');
		if (ch >= 'a' && ch <= 'f')return (char)(ch - 'a' + 10);
		if (ch >= 'A' && ch <= 'F')return (char)(ch - 'A' + 10);
		return -1;
	}

	char StrToBin(IN char(&str)[2])
	{
		char tempWord[2];
		char chn;

		tempWord[0] = CharToInt(str[0]);                         //make the B to 11 -- 00001011
		tempWord[1] = CharToInt(str[1]);                         //make the 0 to 0  -- 00000000

		chn = (tempWord[0] << 4) | tempWord[1];                //to change the BO to 10110000

		return chn;
	}

	CHAR* UNICODE2ASCII(IN LPWCH lpUNICODEStr)
	{
		if (lpUNICODEStr == NULL)
			return NULL;

		// ȡַֽֽ;
		int cbMultiByte = WideCharToMultiByte(CP_OEMCP, 0, lpUNICODEStr, -1, NULL, 0, NULL, NULL);
		if (cbMultiByte == 0)
			return NULL;

		// תɶַֽ;
		CHAR *pMultiByteStr = new CHAR[cbMultiByte + 1];
		memset(pMultiByteStr, 0, cbMultiByte + 1);
		int nWriteNum = WideCharToMultiByte(CP_OEMCP, 0, lpUNICODEStr, -1, pMultiByteStr, cbMultiByte, NULL, NULL);
		if (nWriteNum != cbMultiByte)
		{
			if (pMultiByteStr)
				delete[]pMultiByteStr;
			return NULL;
		}

		pMultiByteStr[cbMultiByte] = '\0';

		return pMultiByteStr;
	}

	BOOL UNICODE2ASCII(IN LPWCH lpUNICODEStr, OUT LPCH pASCIIStr, IN CONST INT& nASCIIStrLen)
	{
		if (lpUNICODEStr == NULL)
			return FALSE;

		// ȡַֽֽ;
		int cbMultiByte = WideCharToMultiByte(CP_OEMCP, 0, lpUNICODEStr, -1, NULL, 0, NULL, NULL);
		if (cbMultiByte == 0 || cbMultiByte >= nASCIIStrLen)
			return FALSE;

		// תɶַֽ;
		memset((void*)pASCIIStr, 0, nASCIIStrLen);
		int nWriteNum = WideCharToMultiByte(CP_OEMCP, 0, lpUNICODEStr, -1, pASCIIStr, cbMultiByte, NULL, NULL);
		if (nWriteNum != cbMultiByte)
		{
			return FALSE;
		}

		return TRUE;
	}

	/************************************************************************/
	/*  [7/26/2016 IT];
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	string DeCode_URLUNICODE(IN const CHAR* pURLText)
	{
		string str = pURLText;
		string strResult = "";

		INT nIndex = 0;
		string strTemp = "";

		while (str.find("\\u", 0, 2) != string::npos)
		{
			nIndex = str.find("\\u", 0, 2);
			strResult.append(str.substr(0, nIndex));
			strTemp = str.substr(nIndex + 2, 4);
			str = str.substr(nIndex + 2 + 4);
			CHAR szReturn[10] = { 0 };

			union  __UNION_VAR_INT {
				BYTE   ch[2];
				int	   value;
			}unionVarInt;

			unionVarInt.ch[0] = (CharToInt(strTemp.at(2)) << 4) | (CharToInt(strTemp.at(3)) & 0x00FF);
			unionVarInt.ch[1] = (CharToInt(strTemp.at(0)) << 4) | (CharToInt(strTemp.at(1)) & 0x00FF);

			WCHAR szWide[2] = { 0 };
			szWide[0] = unionVarInt.value;
			UNICODE2ASCII(szWide, szReturn, 10);
			strResult.append(szReturn);
		}
		strResult.append(str);

		return strResult;
	}

	// ͨעϵͳǰϢ;
	
	BOOL IsValidString(LPCTSTR lpszString)
	{
		if (lpszString == NULL)
			return FALSE;

		do
		{
			// ASCIIʾַ;
			if (*lpszString < 32 || *lpszString > 126)
			{
				return FALSE;
			}
		} while (*++lpszString);

		return TRUE;
	}

	BOOL Python27Dir()
	{
		HKEY hKey;
		int ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\WOW6432Node\\Python\\PythonCore\\2.7\\InstallPath"), 0, KEY_QUERY_VALUE, &hKey);
		if (ret != ERROR_SUCCESS)
			return FALSE;

		//ȡKEY
		DWORD dwType = REG_SZ; //
		DWORD cbData = MAX_PATH;
		ret = RegQueryValueEx(hKey, _T(""), NULL, &dwType, (LPBYTE)g_szPython27Dir, &cbData);
		if (ret != ERROR_SUCCESS)
		{
			RegCloseKey(hKey);
			return FALSE;
		}
		RegCloseKey(hKey);

		return TRUE;
	}

	void GetResourceCfg()
	{
		// ļ;
		Python27Dir();
		TCHAR szConfig[MAX_PATH] = {0};
		_stprintf_s(szConfig, _T("%sLib\\site-packages\\ssat_sdk\\config\\resource_run.cfg"), g_szPython27Dir);

		// Ӵں;
		GetPrivateProfileString(_T("COMM"), _T("serial_communicator_port"), NULL, g_szTVPort, MAX_PATH, szConfig);
		// ؼ;
		g_bWatchTVPort = GetPrivateProfileInt(_T("Abnormal"), _T("Watch"), 0, szConfig);
		// ؼ;
		GetPrivateProfileString(_T("Abnormal"), _T("reboot"), NULL, g_szTVReboot, MAX_PATH, szConfig);
		// ػؼ;
		GetPrivateProfileString(_T("Abnormal"), _T("shutdown"), NULL, g_szTVShutdown, MAX_PATH, szConfig);
	}

	void Split(std::string str1, std::string str2, std::vector<std::string> &vt)
	{
		if ( str1.size() == 0 || str2.size() == 0 )
			return;

		int npos = str1.find(str2);
		while( std::string::npos != npos )
		{
			vt.push_back(str1.substr(0, npos));
			str1 = str1.substr(npos + str2.size());
			npos = str1.find(str2);
		}

		if ( str1.size() )
			vt.push_back(str1);
	}
} // namespace Global