#include "StdAfx.h"
#include "Device.h"
#include <regex> 

std::map<int, CDevice*> g_dmap;
CDevice::CDevice()
{
}

CDevice::~CDevice()
{
	m_obj.CloseSerialPort();
}

bool CDevice::Open()
{
	return m_obj.OpenSerialPort(m_iPort, m_iBaudrate, m_iDatabit, m_iParitybit, m_iStopbit, 0, 0);
}

void CDevice::Close()
{
	m_obj.CloseSerialPort();
}

bool CDevice::IsOpen()
{
	return m_obj.IsOpen();
}

std::string CDevice::SendCommond(std::string cmd)
{
	if ( !m_obj.IsOpen() )
		return std::string("δ򿪳ɹ");

	DWORD dwRet = m_obj.WriteComm((byte*)cmd.data(), cmd.size());
	if ( dwRet != cmd.size() )
		return std::string("дʧ");

	// timptnͬʱ;
	std::string pattern{ "run tim (\\d{1,3});run ptn (\\d{1,3});\r" }; // fixed telephone 
	std::regex re(pattern);
	WORD timeout = 300;
	if (std::regex_match(cmd, re))
		timeout = 1000;
	

	byte szData[1024 * 4] = {0};
	dwRet = m_obj.ReadComm(szData, 1024 * 4, timeout);
	if (dwRet == 0 )
		return std::string("ʧ");

	return std::string((char*)szData, dwRet);
}
