#pragma once

// winsock 2 ͷļͿ
#include <winsock2.h>
#include <MSWSock.h>
//#include <ws2tcpip.h>
#pragma comment(lib,"ws2_32.lib")
#include "SATProtocol.h"

//  (1024*8)
// ֮Ϊʲô8KҲһϵľֵ
// ȷʵͻ˷ÿݶȽ٣ôõСһЩʡڴ
#define MAX_BUFFER_LEN        8192  
// Ĭ϶˿
#define DEFAULT_PORT          12345    
// ĬIPַ
#define DEFAULT_IP            _T("127.0.0.1")

#pragma pack(push)
#pragma pack(1)

typedef struct _PRO_HEADER_
{
	byte	version;
	unsigned int len; // header+buf;
}ProHeader;

// 
typedef struct _PRO_PACKAGE_
{
	ProHeader header;
	byte	buf[4]; // jsonʽ;
}ProPackage;
#pragma pack(pop)

typedef struct _REQUEST_JSON_
{
	int			device_id;
	std::string		device_name;
	std::string device_cmd;
	int	device_timeout;
}RequesJson;

typedef struct _RESPONSE_JSON_
{
	int			device_id;
	std::string		device_name;
	std::string device_cmd_result;	// ִн;
}ResponseJson;


//////////////////////////////////////////////////////////////////
// ɶ˿ͶݵI/O
typedef enum _OPERATION_TYPE  
{  
	ACCEPT_POSTED,                     // ־ͶݵAccept
	SEND_POSTED,                       // ־ͶݵǷͲ
	RECV_POSTED,                       // ־Ͷݵǽղ
	NULL_POSTED                        // ڳʼ

}OPERATION_TYPE;

//====================================================================================
//
//				IOݽṹ嶨(ÿһصĲ)
//
//====================================================================================

typedef struct _PER_IO_CONTEXT
{
	OVERLAPPED     m_Overlapped;                               // ÿһصصṹ(ÿһSocketÿһҪһ)              
	SOCKET         m_sockAccept;                               // ʹõSocket
	WSABUF         m_wsaBuf;                                   // WSA͵Ļڸص
	char           m_szBuffer[MAX_BUFFER_LEN];                 // WSABUFַĻ
	OPERATION_TYPE m_OpType;                                   // ʶ(Ӧö)

	// ʼ
	_PER_IO_CONTEXT()
	{
		ZeroMemory(&m_Overlapped, sizeof(m_Overlapped));  
		ZeroMemory( m_szBuffer,MAX_BUFFER_LEN );
		m_sockAccept = INVALID_SOCKET;
		m_wsaBuf.buf = m_szBuffer;
		m_wsaBuf.len = MAX_BUFFER_LEN;
		m_OpType     = NULL_POSTED;
	}
	// ͷŵSocket
	~_PER_IO_CONTEXT()
	{
		if( m_sockAccept!=INVALID_SOCKET )
		{
			closesocket(m_sockAccept);
			m_sockAccept = INVALID_SOCKET;
		}
	}
	// û
	void ResetBuffer()
	{
		ZeroMemory( m_szBuffer,MAX_BUFFER_LEN );
	}

} PER_IO_CONTEXT, *PPER_IO_CONTEXT;


//====================================================================================
//
//				ݽṹ嶨(ÿһɶ˿ڣҲÿһSocketĲ)
//
//====================================================================================

typedef struct _PER_SOCKET_CONTEXT
{  
	SOCKET      m_Socket;                                  // ÿһͻӵSocket
	SOCKADDR_IN m_ClientAddr;                              // ͻ˵ĵַ
	CArray<_PER_IO_CONTEXT*> m_arrayIoContext;             // ͻݣ
	                                                       // Ҳ˵ÿһͻSocketǿͬʱͶݶIO
	std::string lastData;

	// ʼ
	_PER_SOCKET_CONTEXT()
	{
		m_Socket = INVALID_SOCKET;
		memset(&m_ClientAddr, 0, sizeof(m_ClientAddr)); 
	}

	// ͷԴ
	~_PER_SOCKET_CONTEXT()
	{
		if( m_Socket!=INVALID_SOCKET )
		{
			closesocket( m_Socket );
		    m_Socket = INVALID_SOCKET;
		}
		// ͷŵеIO
		for( int i=0;i<m_arrayIoContext.GetCount();i++ )
		{
			delete m_arrayIoContext.GetAt(i);
		}
		m_arrayIoContext.RemoveAll();
	}

	// ȡһµIoContext
	_PER_IO_CONTEXT* GetNewIoContext()
	{
		_PER_IO_CONTEXT* p = new _PER_IO_CONTEXT;

		m_arrayIoContext.Add( p );

		return p;
	}

	// ƳһָIoContext
	void RemoveContext( _PER_IO_CONTEXT* pContext )
	{
		ASSERT( pContext!=NULL );

		for( int i=0;i<m_arrayIoContext.GetCount();i++ )
		{
			if( pContext==m_arrayIoContext.GetAt(i) )
			{
				delete pContext;
				pContext = NULL;
				m_arrayIoContext.RemoveAt(i);				
				break;
			}
		}
	}

} PER_SOCKET_CONTEXT, *PPER_SOCKET_CONTEXT;




//====================================================================================
//
//				CIOCPModelඨ
//
//====================================================================================

// ̵̲߳߳
class CIOCPModel;
typedef struct _tagThreadParams_WORKER
{
	CIOCPModel* pIOCPModel;                                   // ָ룬ڵеĺ
	int         nThreadNo;                                    // ̱߳

} THREADPARAMS_WORKER,*PTHREADPARAM_WORKER; 

// CIOCPModel
class CIOCPModel
{
public:
	CIOCPModel(void);
	~CIOCPModel(void);

public:

	// 
	bool Start(unsigned int port);

	//	ֹͣ
	void Stop();

	// Socket
	bool LoadSocketLib();

	// жSocket⣬
	void UnloadSocketLib() { WSACleanup(); }

	// ñIPַ
	CString GetLocalIP();

	// ü˿
	void SetPort( const int& nPort ) { m_nPort=nPort; }

	// ָ룬ڵʾϢ
	void SetMainDlg( CDialog* p ) { m_pMain=p; }

protected:

	// ʼIOCP
	bool _InitializeIOCP();

	// ʼSocket
	bool _InitializeListenSocket(unsigned int port);

	// ͷԴ
	void _DeInitialize();

	// ͶAccept
	bool _PostAccept( PER_IO_CONTEXT* pAcceptIoContext ); 

	// Ͷݽ
	bool _PostRecv( PER_IO_CONTEXT* pIoContext );

	// пͻʱ򣬽д
	bool _DoAccpet( PER_SOCKET_CONTEXT* pSocketContext, PER_IO_CONTEXT* pIoContext );

	// нյݵʱ򣬽д
	bool _DoRecv( PER_SOCKET_CONTEXT* pSocketContext, PER_IO_CONTEXT* pIoContext );

	// ͻ˵Ϣ洢
	void _AddToContextList( PER_SOCKET_CONTEXT *pSocketContext );

	// ͻ˵ϢƳ
	void _RemoveContext( PER_SOCKET_CONTEXT *pSocketContext );

	// տͻϢ
	void _ClearContextList();

	// 󶨵ɶ˿
	bool _AssociateWithIOCP( PER_SOCKET_CONTEXT *pContext);

	// ɶ˿ϵĴ
	bool HandleError( PER_SOCKET_CONTEXT *pContext,const DWORD& dwErr );

	// ̺߳ΪIOCPĹ߳
	static DWORD WINAPI _WorkerThread(LPVOID lpParam);

	// ñĴ
	int _GetNoOfProcessors();

	// жϿͻSocketǷѾϿ
	bool _IsSocketAlive(SOCKET s);

	// ʾϢ
	void _ShowMessage( const CString szFormat,...) const;

	void _RecvProcess(PER_SOCKET_CONTEXT* pSocketContext, PER_IO_CONTEXT* pIoContext);
	void _TaskProcess(PER_IO_CONTEXT* pIoContext, ProPackage* pak);
	// 崦;
	void _DeviceProc(PER_IO_CONTEXT* pIoContext, ProPackage*pak);
	void _CaptureProc(PER_IO_CONTEXT* pIoContext, ProPackage* pak);
private:

	HANDLE                       m_hShutdownEvent;              // ֪ͨ߳ϵͳ˳¼Ϊܹõ˳߳

	HANDLE                       m_hIOCompletionPort;           // ɶ˿ڵľ

	HANDLE*                      m_phWorkerThreads;             // ̵߳ľָ

	int		                     m_nThreads;                    // ɵ߳

	CString                      m_strIP;                       // ˵IPַ
	int                          m_nPort;                       // ˵ļ˿

	CDialog*                     m_pMain;                       // Ľָ룬ʾϢ

	CRITICAL_SECTION             m_csContextList;               // Worker߳ͬĻ

	CArray<PER_SOCKET_CONTEXT*>  m_arrayClientContext;          // ͻSocketContextϢ        

	PER_SOCKET_CONTEXT*          m_pListenContext;              // ڼSocketContextϢ

	LPFN_ACCEPTEX                m_lpfnAcceptEx;                // AcceptEx  GetAcceptExSockaddrs ĺָ룬ڵչ
	LPFN_GETACCEPTEXSOCKADDRS    m_lpfnGetAcceptExSockAddrs; 

};

