///************************************************************************/
/*  Copyright (C), 2010-2020, [Jeff], Ȩ;
/*  ģ  ;
/*      ;
/*
/*      [V];	
/*      ߣ[Jeff];
/*      ڣ[];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[Jeff];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/

#ifndef __HOME_GLOBAL__
#define __HOME_GLOBAL__

#pragma once

#include <string>
#include <vector>
using namespace std;

#ifndef _UNICODE
typedef string TString;
#else
typedef wstring TString;
#endif

namespace Global
{
	typedef struct __ST_SAT_CFG__ 
	{
		int nAdbTimeout;
		TCHAR szScriptDir[MAX_PATH];		// ű·;
		TCHAR szApkServer[MAX_PATH];
		TCHAR szApkSysCode[MAX_PATH];

		TCHAR szCaseServer[MAX_PATH];
		TCHAR szCaseSysCode[MAX_PATH];

		TCHAR szTaskServer[MAX_PATH];
		TCHAR szTaskSysCode[MAX_PATH];

		TCHAR szResultServer[MAX_PATH];
		//TCHAR szResultSysCode[MAX_PATH];

		TCHAR szExecuteServer[MAX_PATH];
		TCHAR szExecuteSysCode[MAX_PATH];

		TCHAR szResultExcelDir[MAX_PATH];
		typedef struct  __ST_LD__
		{
			TCHAR szDevice[MAX_PATH];
			TCHAR szManu[MAX_PATH];
			TCHAR szHardwareVersion[MAX_PATH];
			TCHAR szModel[MAX_PATH];
		}STLinuxDevice, *pSTLinuxDevice;

		STLinuxDevice stLinuxDevice;
	}STSATConfig, *pSTSATConfig;

	extern STSATConfig g_stSATConfig;
	//////////////////////////////////////////////////////////////////////////
	// ȫֱ;
	//////////////////////////////////////////////////////////////////////////
	extern TCHAR g_szIniFile[MAX_PATH];
	extern TCHAR g_szHostName[MAX_PATH];			// ;
	extern TCHAR g_szConnectString[MAX_PATH];		// DBӴ;

	// Ϣ;
	extern TCHAR g_szDBSource[MAX_PATH];			// ݿԴ(IP);
	extern TCHAR g_szDBSourcePort[MAX_PATH];		// ݿԴ˿;
	extern DWORD g_dwDBServerPort;					// ݿԴ˿;
	extern TCHAR g_szDBAccount[MAX_PATH];			// ݿ¼û;
	extern TCHAR g_szDBPassWord[MAX_PATH];			// ݿ¼;
	extern TCHAR g_szDBName[MAX_PATH];				// ݿ;	

	extern TCHAR g_szCurModuleFileName[MAX_PATH];
	extern TCHAR g_szCurModuleDir[MAX_PATH];
	extern TCHAR g_szCurModulePath[MAX_PATH];
	extern TCHAR g_szFna[_MAX_FNAME];
	extern TCHAR g_szExt[_MAX_EXT];



	//////////////////////////////////////////////////////////////////////////
	// ;
	enum NICKIND {
		// pci;
		NIC_PCI,
		// usb;
		NIC_USB,
		// ;
		NIC_ROOT,
		// ;
		NIC_SWD,
		// δ֪;
		NIC_UNK
	};

	typedef struct __MAC_ADDRESS__
	{
		INT nNICKind;
		TCHAR szNICKind[16];
		TCHAR szMacAddress[MAX_PATH];
		TCHAR szDevicePath[MAX_PATH];
	} MacAddress, * pMacAddress;

	extern std::string g_strMacs;
	extern std::vector<MacAddress> g_vtMac;
	//////////////////////////////////////////////////////////////////////////

	//////////////////////////////////////////////////////////////////////////
	// ȫֺ;
	// жϹǷЧ;
	extern BOOL IsValidDate(IN LPCTSTR lpDate);
	// жũǷЧ;
	extern BOOL IsValidLunanrDate(IN LPCTSTR lpDate);
	// ȡļ;
	extern int GetIniInfo(IN const TCHAR *szPath = NULL, const TCHAR *szIniName = NULL);

	// ȡַ;
	INT GetMacAddress();
	//////////////////////////////////////////////////////////////////////////
	// ַϵȫֺ;
	extern BOOL CompareNoCase(IN TString& str1, IN TString& str2);
	extern BOOL IsStringExist(IN CString& str, IN CStringArray &tagAry);
	extern BOOL IsStringExist(IN TString& str, IN vector<TString> &tagVt);
	extern BOOL IsStringExistNoCase(IN CString& str, IN CStringArray &tagAry);
	extern BOOL IsStringExistNoCase(IN CONST TString& str, IN CStringArray &tagAry);
	extern BOOL IsStringExistNoCase(IN CONST TString& str, IN vector<TString> &tagVt);
	extern TString lowercase(IN const TString &Str);
	extern TString uppercase(IN const TString &Str);
	extern int match(IN CONST TString &sExt, IN CONST TString &sFile);
	extern TString getfilename(IN CONST TString &file);
	extern CString getfilename(IN CONST CString &file);

	//////////////////////////////////////////////////////////////////////////
	// غ;
	extern BOOL FindAppProcessID(IN CString path, OUT DWORD &dwProcessID);
	extern DWORD FindProcess(IN CString strProName);
	extern DWORD FindProcessCount(IN LPCTSTR lpExeName);
	extern int FindAndCloseProcess(IN CString strProName);

	// ļ;
	extern  BOOL GetDiskSpaceInfo(IN LPCTSTR lpRootPathName,IN OUT double &dTotalNum, IN OUT double &dFreeNum);

	extern BOOL GetFileVersion( IN HMODULE hModule, IN DWORD (&dwArray)[4]);
	extern BOOL GetFileVersionEx( IN LPCTSTR lpFileName, IN DWORD (&dwArray)[4] );
	extern BOOL GetProductVersion( IN HMODULE hModule, IN DWORD (&dwArray)[4]);
	extern BOOL GetProductVersionEx( IN LPCTSTR lpFileName, IN DWORD (&dwArray)[4] );

	// ȡļе޸ʱ;
	extern BOOL GetDirLastWriteTime(IN LPCTSTR lpDirName, OUT LPTSTR lpszString, IN CONST DWORD& dwSize);
	// ļе޸ʱ;
	extern BOOL SetDirLastWriteTime();
	// ȡָļ޸ʱ;
	extern BOOL GetLastWriteTime(IN HANDLE hFile, OUT LPTSTR lpszString, IN CONST DWORD& dwSize);
	// ָļе޸ʱ;
	extern BOOL SetFileLastWirteTime(IN LPCTSTR lpDirName, IN SYSTEMTIME &st);
	// ɾָĿ¼ļ;
	extern void DeleteDirectory(CString strDir);
	//
	extern void GetHostName();
	// Ŀ¼;
	bool MKDIR(LPCTSTR dir);
	void WriteTextLog(const TCHAR* format, ...);
	// дű־;
	void WritePythonLog(LPCTSTR file, const TCHAR* msg);
	// ȡIPַ;
	std::string GetLocalAddress(int nType = MIB_IF_TYPE_ETHERNET);
};

#endif