#ifndef __SAT_QUERIER__
#define __SAT_QUERIER__

#pragma once

#include "CritSection.h"

enum DEVICE_TYPE{
	Virtual,
	Usb,
	Reticle
};

typedef struct __DEVICE__
{
	int 			nType;		// 0=, 1=usb, 2=;
	std::string 	strName;	// 豸(IP:˿ں);
	// ʱָ̣ʱɾ豸,߳ʵʱˢʱ;
	ULONGLONG		ulOfflineTime;
}STDevice, *pSTDevice;

// ׿豸adbӣUSBӡ;
typedef struct __DEVICE_INFO__ 
{
	STDevice		dev;
	//////////////////////////////////////////////////////////////////////////
	// ;
	int				nStatus;		// 豸״̬0ʾ,1ʾæ;
	std::string		strSoftVersion;	// 汾;
	std::string		strModel;		// ģ;
	std::string		strHardVersion;	// Ӳ汾;
	std::string		strManu;		// ˵;		
}STDeviceInfo, *pSTDeviceInfo;

class CSATDevices
{
	CSATDevices(void);
public:
	// ģʽ;
	static CSATDevices* GetInstance()
	{
		static CSATDevices* pInstance = NULL;
		if ( pInstance == NULL )
		{
			pInstance = new CSATDevices;
		}

		return pInstance;
	}

	~CSATDevices(void);

protected:
	// ߳̿ƾ;
	HANDLE  m_hEvent;
	// ߳̾;
	HANDLE	m_hWorkThread;

	// Ƿ׿豸;
	static bool s_bEnableAndroid;
	// ߲ʱ,λ;
	static ULONGLONG s_ulEraseDuration;	
	// ߳;
	static ThreadSection s_ThreadSection;
	// ׿豸б;
	static std::vector<STDevice> s_vtDevices;	

	// ӿ;
public:
	// ʼ;	
	void StartWork();
	// ;
	void EndofWork();

	// ߳;
	static DWORD WINAPI WorkThread(LPVOID lpVoid);


	// ɾ豸;
	static void DelDevices(std::string name);
	// 豸;
	static void AddReticleDevices(std::string ip);
	static void AddVirtualDevices(std::string name);
	// 豸Ƿ;
	static bool IsDeviceExist(STDevice &stDevice);
	// 豸Ƿ;
	static bool IsAndroidOffline(STDevice &stDevice, std::vector<STDevice> &vtDevices);
	static bool IsAndroidOffline(std::string strDeviceName, std::vector<STDevice> &vtDevices );
	// Ƿ豸;
	static bool IsNewAndroid(STDevice &stDevice);
	static bool IsNewUsbAndroid(STDevice &stDevice);
	// ȡǰ豸б;
	static void GetCurrentDevices(std::vector<STDevice> &vtDevices);
	// 豸;
	static void ReConnectAllDevices();

	// 豸;
	static int AttachDeviceName2Buffer(char (&pbuff)[30][MAX_PATH]);

};

#endif // __SAT_QUERIER__