// SATService.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"
#include "SATService.h"
#include "MainProcess.h"
#include "SATExecutor.h"
#include "SATDevices.h"
#include "SATTCPServer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// ΨһӦó

CWinApp theApp;

using namespace std;

extern int test();

// ص;
void CALLBACK WorkStart()
{
	WindowsService::GetDebugPriv();

#ifdef _DEBUG
	CSATExecutor::GetInstance()->Login("superAdmin", "123456", "SAT-Admin");
	CSATExecutor::GetInstance()->UpdateDevice();
#endif
	// SATִ;
	CSATExecutor::GetInstance()->StartWork();
	// SAT TCP;
	CSATTCPServer::GetInstance()->LoadSocketLib();
	CSATTCPServer::GetInstance()->Start(5588);
	// 豸ɨ;
	CSATDevices::GetInstance()->StartWork();
}

// ص;
void CALLBACK WorkEndof()
{
	Global::WriteTextLog("SATService goto end");
	CSATTCPServer::GetInstance()->Stop();
	CSATTCPServer::GetInstance()->UnloadSocketLib();
	CMainProcess::GetInstance()->EndofWork();
	Global::WriteTextLog("SATService work end!");
}


int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// ֱӻǰڵľ;
	HWND hwnd = GetForegroundWindow(); 
	SendMessage(hwnd , WM_SETICON, ICON_SMALL, (LPARAM)LoadIcon(NULL,MAKEINTRESOURCE(IDI_MICON)));
	HMODULE hModule = ::GetModuleHandle(NULL);

	// ʼ MFC ʧʱʾ
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: ĴԷҪ
		_tprintf(_T(": MFC ʼʧ\n"));
		nRetCode = 1;
	}
	else
	{
		// TODO: ڴ˴ΪӦóΪд롣
		Global::GetIniInfo();
		Global::GetMacAddress();
		Global::WriteTextLog("SATService goto start");
#ifdef _DEBUG

#if 0
		// SATִ;
		CSATExecutor::GetInstance()->Login("superAdmin", "123456");
		CSATExecutor::GetInstance()->UpdateDevice();
		CSATExecutor::GetInstance()->StartWork();
#endif

#if 1
		// SAT TCP;
		CSATTCPServer::GetInstance()->LoadSocketLib();
		CSATTCPServer::GetInstance()->Start(5588);
#endif

#if 0
		CSATDevices::GetInstance()->StartWork();
#endif

		// ָʱֹͣ;
		ULONGLONG ulTickCount = GetTickCount64();
		while (GetTickCount64() - ulTickCount < 1800000 )
		{
			//CSATExecutor::GetInstance()->Login("superAdmin", "123456");
			//printf("ʱ%ld\n",GetTickCount64() - ulTickCount);
			Sleep(100);
		}
		
		return 0;
#endif
		// ̴,ֱ˳;
		TCHAR szExeName[MAX_PATH] = {0};
		TCHAR szDrive[_MAX_DRIVE] = { 0 };
		TCHAR szDir[_MAX_DIR] = { 0 };
		TCHAR szFna[_MAX_FNAME] = { 0 };
		TCHAR szExt[_MAX_EXT] = { 0 };
		_tsplitpath_s(Global::g_szCurModuleFileName, szDrive, szDir, szFna, szExt);
		_stprintf_s(szExeName, _T("%s%s"), szFna, szExt);
		if ( Global::FindProcessCount(szExeName) > 1)
		{// ̼1,˳;
			return 0;
		}

		// ÷;
		_stprintf_s(WindowsService::g_szSvcName, _T("SAT Service"));
		_stprintf_s(WindowsService::g_szlpSvrDescription, _T("SATԶ"));

		// 1.жϷǷ;
		if ( WindowsService::IsSvcInstalled())
		{
			// жط;
			if ( argc > 1)
			{
				if (_tcscmp((TCHAR *)argv[1], _T("/uninstall")) == 0)
					WindowsService::DoDeleteSvc(WindowsService::g_szSvcName);
				else
					_tprintf_s(_T("δжط\n"));

				return 0;
			}
			else 
			{
				WindowsService::InitSvcVar();
				WindowsService::SetCallBack(WorkStart, WorkEndof);
				SERVICE_TABLE_ENTRY st[] =
				{
					{ WindowsService::g_szSvcName, (LPSERVICE_MAIN_FUNCTION)WindowsService::ServiceMain },
					{ NULL, NULL }
				};

				if (!::StartServiceCtrlDispatcher(st))	// ֱ˫.exeʱ,ⲽʧ;
				{
					//LOG4C((LOG_NOTICE,"Ѱװ,ϵͳп"));
					WindowsService::SvcReportEvent(_T("Register Service Main Function Error!"));
					return 0;
				}
			}
		}

		// 2.,װ;
		WindowsService::InitSvcVar();
		WindowsService::SetCallBack(WorkStart, WorkEndof);
		SERVICE_TABLE_ENTRY st[] =
		{
			{ WindowsService::g_szSvcName, (LPSERVICE_MAIN_FUNCTION)WindowsService::ServiceMain },
			{ NULL, NULL }
		};

		WindowsService::SvcInstall();
	}

	return nRetCode;
}
