#include "StdAfx.h"
#include "SATTCPServer.h"
//#include "MainDlg.h"
#include "SATExecutor.h"
#include "SATDevices.h"

// ÿһϲٸ߳(Ϊ޶ȵܣĵ)
#define WORKER_THREADS_PER_PROCESSOR 2
// ͬʱͶݵAccept(Ҫʵʵ)
#define MAX_POST_ACCEPT              10
// ݸWorker̵߳˳ź
#define EXIT_CODE                    NULL


// ͷָ;Դĺ

// ͷָ
#define RELEASE(x)                      {if(x != NULL ){delete x;x=NULL;}}
// ͷž
#define RELEASE_HANDLE(x)               {if(x != NULL && x!=INVALID_HANDLE_VALUE){ CloseHandle(x);x = NULL;}}
// ͷSocket
#define RELEASE_SOCKET(x)               {if(x !=INVALID_SOCKET) { closesocket(x);x=INVALID_SOCKET;}}



CSATTCPServer::CSATTCPServer(void):
							m_nThreads(0),
							m_hShutdownEvent(NULL),
							m_hIOCompletionPort(NULL),
							m_phWorkerThreads(NULL),
							m_strIP(DEFAULT_IP),
							m_nPort(DEFAULT_PORT),
							m_pMain(NULL),
							m_lpfnAcceptEx( NULL ),
							m_pListenContext( NULL )
{
}


CSATTCPServer::~CSATTCPServer(void)
{
	// ȷԴͷ
	this->Stop();
}




///////////////////////////////////////////////////////////////////
// ̣߳  ΪIOCPĹ߳
//         Ҳÿɶ˿ϳݰͽ֮ȡд߳
///////////////////////////////////////////////////////////////////

DWORD WINAPI CSATTCPServer::_WorkerThread(LPVOID lpParam)
{    
	THREADPARAMS_WORKER* pParam = (THREADPARAMS_WORKER*)lpParam;
	CSATTCPServer* pIOCPModel = (CSATTCPServer*)pParam->pIOCPModel;
	int nThreadNo = (int)pParam->nThreadNo;

	pIOCPModel->_ShowMessage(_T("߳ID: %d."),nThreadNo);

	OVERLAPPED           *pOverlapped = NULL;
	PER_SOCKET_CONTEXT   *pSocketContext = NULL;
	DWORD                dwBytesTransfered = 0;

	// ѭ֪յShutdownϢΪֹ
	while (WAIT_OBJECT_0 != WaitForSingleObject(pIOCPModel->m_hShutdownEvent, 0))
	{
		BOOL bReturn = GetQueuedCompletionStatus(
			pIOCPModel->m_hIOCompletionPort,
			&dwBytesTransfered,
			(PULONG_PTR)&pSocketContext,
			&pOverlapped,
			INFINITE);

		// յ˳־ֱ˳
		if ( EXIT_CODE==(DWORD)pSocketContext )
		{
			pIOCPModel->_ShowMessage(_T("յ˳־ֱ˳ID: %d."),nThreadNo);
			break;
		}

		// жǷ˴
		if( !bReturn )  
		{  
			DWORD dwErr = GetLastError();

			// ʾһʾϢ
			if( !pIOCPModel->HandleError( pSocketContext,dwErr ) )
			{
				break;
			}

			continue;  
		}  
		else  
		{  	
			// ȡĲ
			PER_IO_CONTEXT* pIoContext = CONTAINING_RECORD(pOverlapped, PER_IO_CONTEXT, m_Overlapped);  

			// жǷпͻ˶Ͽ
			if((0 == dwBytesTransfered) && ( RECV_POSTED==pIoContext->m_OpType || SEND_POSTED==pIoContext->m_OpType))  
			{  
				pIOCPModel->_ShowMessage( _T("ͻ %s:%d Ͽ."),
					inet_ntoa(pSocketContext->m_ClientAddr.sin_addr), 
					ntohs(pSocketContext->m_ClientAddr.sin_port) );

				// ͷŵӦԴ
				pIOCPModel->_RemoveContext( pSocketContext );

 				continue;  
			}  
			else
			{
				switch( pIoContext->m_OpType )  
				{  
					 // Accept  
				case ACCEPT_POSTED:
					{ 
						// ΪӴɶԣרŵ_DoAcceptд
						pIOCPModel->_DoAccpet( pSocketContext, pIoContext );		
					}
					break;

					// RECV
				case RECV_POSTED:
					{
						// ΪӴɶԣרŵ_DoRecvд
						pIOCPModel->_DoRecv( pSocketContext,pIoContext );
					}
					break;

					// SEND
					// ԹдˣҪ̫ˣ⣬SendһЩ
				case SEND_POSTED:
					{

					}
					break;
				default:
					// Ӧִе
					TRACE(_T("_WorkThreadе pIoContext->m_OpType 쳣.\n"));
					break;
				} //switch
			}//if
		}//if

	}//while

	TRACE(_T("߳ %d ˳.\n"),nThreadNo);

	// ͷ̲߳
	RELEASE(lpParam);	

	return 0;
}



//====================================================================================
//
//				    ϵͳʼֹ
//
//====================================================================================




////////////////////////////////////////////////////////////////////
// ʼWinSock 2.2
bool CSATTCPServer::LoadSocketLib()
{    
	WSADATA wsaData;
	int nResult;
	nResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	// (һ㶼ܳ)
	if (NO_ERROR != nResult)
	{
		this->_ShowMessage(_T("ʼWinSock 2.2ʧܣ\n"));
		return false; 
	}

	return true;
}

//////////////////////////////////////////////////////////////////
//	
bool CSATTCPServer::Start(unsigned int port)
{
	// ʼ̻߳
	InitializeCriticalSection(&m_csContextList);

	// ϵͳ˳¼֪ͨ
	m_hShutdownEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	// ʼIOCP
	if (false == _InitializeIOCP())
	{
		this->_ShowMessage(_T("ʼIOCPʧܣ\n"));
		return false;
	}
	else
	{
		this->_ShowMessage(_T("\nIOCPʼ\n."));
	}

	// ʼSocket
	if( false==_InitializeListenSocket(port) )
	{
		this->_ShowMessage(_T("Listen Socketʼʧܣ\n"));
		this->_DeInitialize();
		return false;
	}
	else
	{
		this->_ShowMessage(_T("Listen Socketʼ."));
	}

	this->_ShowMessage(_T("ϵͳ׼Ⱥ....\n"));

	return true;
}


////////////////////////////////////////////////////////////////////
//	ʼϵͳ˳Ϣ˳ɶ˿ں߳Դ
void CSATTCPServer::Stop()
{
	if( m_pListenContext != NULL && m_pListenContext->m_Socket != INVALID_SOCKET )
	{
		// رϢ֪ͨ
		SetEvent(m_hShutdownEvent);

		for (int i = 0; i < m_nThreads; i++)
		{
			// ֪ͨеɶ˿ڲ˳
			PostQueuedCompletionStatus(m_hIOCompletionPort, 0, (DWORD)EXIT_CODE, NULL);
		}

		// ȴеĿͻԴ˳
		WaitForMultipleObjects(m_nThreads, m_phWorkerThreads, TRUE, INFINITE);

		// ͻбϢ
		this->_ClearContextList();

		// ͷԴ
		this->_DeInitialize();

		this->_ShowMessage(_T("ֹͣ\n"));
	}	
}


////////////////////////////////
// ʼɶ˿
bool CSATTCPServer::_InitializeIOCP()
{
	// һɶ˿
	m_hIOCompletionPort = CreateIoCompletionPort(INVALID_HANDLE_VALUE, NULL, 0, 0 );

	if ( NULL == m_hIOCompletionPort)
	{
		this->_ShowMessage(_T("ɶ˿ʧܣ: %d!\n"), WSAGetLastError());
		return false;
	}

	// ݱеĴӦ߳
	//m_nThreads = WORKER_THREADS_PER_PROCESSOR * _GetNoOfProcessors();
	m_nThreads = _GetNoOfProcessors();
	
	// Ϊ̳߳ʼ
	m_phWorkerThreads = new HANDLE[m_nThreads];
	
	// ݼ߳
	DWORD nThreadID;
	for (int i = 0; i < m_nThreads; i++)
	{
		THREADPARAMS_WORKER* pThreadParams = new THREADPARAMS_WORKER;
		pThreadParams->pIOCPModel = this;
		pThreadParams->nThreadNo  = i+1;
		m_phWorkerThreads[i] = ::CreateThread(0, 0, _WorkerThread, (void *)pThreadParams, 0, &nThreadID);
	}

	TRACE("  _WorkerThread %d .\n", m_nThreads );

	return true;
}


/////////////////////////////////////////////////////////////////
// ʼSocket
bool CSATTCPServer::_InitializeListenSocket(unsigned int port)
{
	// AcceptEx  GetAcceptExSockaddrs GUIDڵָ
	GUID GuidAcceptEx = WSAID_ACCEPTEX;  
	GUID GuidGetAcceptExSockAddrs = WSAID_GETACCEPTEXSOCKADDRS; 

	// ַϢڰSocket
	struct sockaddr_in ServerAddress;

	// ڼSocketϢ
	m_pListenContext = new PER_SOCKET_CONTEXT;

	// ҪʹصIOʹWSASocketSocketſ֧صIO
	m_pListenContext->m_Socket = WSASocket(AF_INET, SOCK_STREAM, 0, NULL, 0, WSA_FLAG_OVERLAPPED);
	if (INVALID_SOCKET == m_pListenContext->m_Socket) 
	{
		this->_ShowMessage(_T("ʼSocketʧܣ: %d.\n"), WSAGetLastError());
		return false;
	}
	else
	{
		TRACE("WSASocket() .\n");
	}

	// Listen Socketɶ˿
	if( NULL== CreateIoCompletionPort( (HANDLE)m_pListenContext->m_Socket, m_hIOCompletionPort,(DWORD)m_pListenContext, 0))  
	{  
		this->_ShowMessage(_T(" Listen Socketɶ˿ʧܣ: %d/n"), WSAGetLastError());  
		RELEASE_SOCKET( m_pListenContext->m_Socket );
		return false;
	}
	else
	{
		TRACE("Listen Socketɶ˿ .\n");
	}

	// ַϢ
	ZeroMemory((char *)&ServerAddress, sizeof(ServerAddress));
	ServerAddress.sin_family = AF_INET;
	// ԰κοõIPַ߰һָIPַ 
	ServerAddress.sin_addr.s_addr = htonl(INADDR_ANY);                      
	//ServerAddress.sin_addr.s_addr = inet_addr(m_strIP.GetString());         
	ServerAddress.sin_port = htons(port);                          

	// 󶨵ַͶ˿
	if (SOCKET_ERROR == ::bind(m_pListenContext->m_Socket, (struct sockaddr *) &ServerAddress, sizeof(ServerAddress))) 
	{
		this->_ShowMessage(_T("bind()ִд! : %d/n"), WSAGetLastError());  
		return false;
	}
	else
	{
		TRACE("bind() .\n");
	}

	// ʼм
	if (SOCKET_ERROR == listen(m_pListenContext->m_Socket,SOMAXCONN))
	{
		this->_ShowMessage(_T("Listen()ִгִ; : %d/n"), WSAGetLastError());  
		return false;
	}
	else
	{
		TRACE("Listen() .\n");
	}

	// ʹAcceptExΪWinSock2淶֮΢ṩչ
	// Ҫȡһºָ룬
	// ȡAcceptExָ
	DWORD dwBytes = 0;  
	if(SOCKET_ERROR == WSAIoctl(
		m_pListenContext->m_Socket, 
		SIO_GET_EXTENSION_FUNCTION_POINTER, 
		&GuidAcceptEx, 
		sizeof(GuidAcceptEx), 
		&m_lpfnAcceptEx, 
		sizeof(m_lpfnAcceptEx), 
		&dwBytes, 
		NULL, 
		NULL))  
	{  
		this->_ShowMessage(_T("WSAIoctl δܻȡAcceptExָ롣: %d\n"), WSAGetLastError()); 
		this->_DeInitialize();
		return false;  
	}  

	// ȡGetAcceptExSockAddrsָ룬Ҳͬ
	if(SOCKET_ERROR == WSAIoctl(
		m_pListenContext->m_Socket, 
		SIO_GET_EXTENSION_FUNCTION_POINTER, 
		&GuidGetAcceptExSockAddrs,
		sizeof(GuidGetAcceptExSockAddrs), 
		&m_lpfnGetAcceptExSockAddrs, 
		sizeof(m_lpfnGetAcceptExSockAddrs),   
		&dwBytes, 
		NULL, 
		NULL))  
	{  
		this->_ShowMessage(_T("WSAIoctl δܻȡGuidGetAcceptExSockAddrsָ롣: %d\n"), WSAGetLastError());  
		this->_DeInitialize();
		return false; 
	}  


	// ΪAcceptEx ׼ȻͶAcceptEx I/O
	for( int i=0;i<MAX_POST_ACCEPT;i++ )
	{
		// ½һIO_CONTEXT
		PER_IO_CONTEXT* pAcceptIoContext = m_pListenContext->GetNewIoContext();

		if( false==this->_PostAccept( pAcceptIoContext ) )
		{
			m_pListenContext->RemoveContext(pAcceptIoContext);
			return false;
		}
	}

	this->_ShowMessage( _T("Ͷ %d AcceptEx"),MAX_POST_ACCEPT );

	return true;
}

////////////////////////////////////////////////////////////
//	ͷŵԴ
void CSATTCPServer::_DeInitialize()
{
	// ɾͻбĻ
	DeleteCriticalSection(&m_csContextList);

	// رϵͳ˳¼
	RELEASE_HANDLE(m_hShutdownEvent);

	// ͷŹָ߳̾
	for( int i=0;i<m_nThreads;i++ )
	{
		RELEASE_HANDLE(m_phWorkerThreads[i]);
	}
	
	RELEASE(m_phWorkerThreads);

	// رIOCP
	RELEASE_HANDLE(m_hIOCompletionPort);

	shutdown(m_pListenContext->m_Socket, SD_BOTH);
	// ȹرն˿;
	RELEASE_SOCKET( m_pListenContext->m_Socket );

	// رռSocket
	RELEASE(m_pListenContext);

	this->_ShowMessage(_T("ͷԴ.\n"));
}


//====================================================================================
//
//				    Ͷɶ˿
//
//====================================================================================


//////////////////////////////////////////////////////////////////
// ͶAccept
bool CSATTCPServer::_PostAccept( PER_IO_CONTEXT* pAcceptIoContext )
{
	ASSERT( INVALID_SOCKET!=m_pListenContext->m_Socket );

	// ׼
	DWORD dwBytes = 0;  
	pAcceptIoContext->m_OpType = ACCEPT_POSTED;  
	WSABUF *p_wbuf   = &pAcceptIoContext->m_wsaBuf;
	OVERLAPPED *p_ol = &pAcceptIoContext->m_Overlapped;
	
	// ΪԺĿͻ׼Socket( 봫ͳaccept ) 
	pAcceptIoContext->m_sockAccept  = WSASocket(AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, WSA_FLAG_OVERLAPPED);  
	if( INVALID_SOCKET==pAcceptIoContext->m_sockAccept )  
	{  
		_ShowMessage(_T("AcceptSocketʧܣ: %d"), WSAGetLastError()); 
		return false;  
	} 

	// ͶAcceptEx
	if(FALSE == m_lpfnAcceptEx( m_pListenContext->m_Socket, pAcceptIoContext->m_sockAccept, p_wbuf->buf, p_wbuf->len - ((sizeof(SOCKADDR_IN)+16)*2),   
								sizeof(SOCKADDR_IN)+16, sizeof(SOCKADDR_IN)+16, &dwBytes, p_ol))  
	{  
		if(WSA_IO_PENDING != WSAGetLastError())  
		{  
			_ShowMessage(_T("Ͷ AcceptEx ʧܣ: %d"), WSAGetLastError());  
			return false;  
		}  
	} 

	return true;
}

////////////////////////////////////////////////////////////
// пͻʱ򣬽д
// е㸴ӣҪǿĻͿ׵ĵ....
// Ļɶ˿ڵĻһ

// ֮Ҫ֪ListenSocketContextҪһݳSocket
// ԭContextҪͶһAccept
//
bool CSATTCPServer::_DoAccpet( PER_SOCKET_CONTEXT* pSocketContext, PER_IO_CONTEXT* pIoContext )
{
	SOCKADDR_IN* ClientAddr = NULL;
	SOCKADDR_IN* LocalAddr = NULL;  
	int remoteLen = sizeof(SOCKADDR_IN), localLen = sizeof(SOCKADDR_IN);  

	///////////////////////////////////////////////////////////////////////////
	// 1. ȡͻ˵ĵַϢ
	//  m_lpfnGetAcceptExSockAddrs ˰~~~~~~
	// ȡÿͻ˺ͱض˵ĵַϢ˳ȡͻ˷ĵһ
	this->m_lpfnGetAcceptExSockAddrs(pIoContext->m_wsaBuf.buf, pIoContext->m_wsaBuf.len - ((sizeof(SOCKADDR_IN)+16)*2),  
		sizeof(SOCKADDR_IN)+16, sizeof(SOCKADDR_IN)+16, (LPSOCKADDR*)&LocalAddr, &localLen, (LPSOCKADDR*)&ClientAddr, &remoteLen);  

	_RecvProcess(pSocketContext, pIoContext);
	this->_ShowMessage( _T("ͻ %s:%d ."), inet_ntoa(ClientAddr->sin_addr), ntohs(ClientAddr->sin_port) );

	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// 2. Ҫע⣬ﴫListenSocketϵContextContextǻҪڼһ
	// һҪListenSocketϵContextƳһΪSocket½һSocketContext

	PER_SOCKET_CONTEXT* pNewSocketContext = new PER_SOCKET_CONTEXT;
	pNewSocketContext->m_Socket           = pIoContext->m_sockAccept;
	memcpy(&(pNewSocketContext->m_ClientAddr), ClientAddr, sizeof(SOCKADDR_IN));

	// ϣSocketɶ˿ڰ(Ҳһؼ)
	if( false==this->_AssociateWithIOCP( pNewSocketContext ) )
	{
		RELEASE( pNewSocketContext );
		return false;
	}  

	///////////////////////////////////////////////////////////////////////////////////////////////////
	// 3. µIoContextSocketͶݵһRecv
	PER_IO_CONTEXT* pNewIoContext = pNewSocketContext->GetNewIoContext();
	pNewIoContext->m_OpType       = RECV_POSTED;
	pNewIoContext->m_sockAccept   = pNewSocketContext->m_Socket;
	// BufferҪԼһݳ
	//memcpy( pNewIoContext->m_szBuffer,pIoContext->m_szBuffer,MAX_BUFFER_LEN );

	// ֮󣬾ͿԿʼSocketͶ
	if( false==this->_PostRecv( pNewIoContext) )
	{
		pNewSocketContext->RemoveContext( pNewIoContext );
		return false;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	// 4. ͶݳɹôͰЧĿͻϢ뵽ContextListȥ(ҪͳһͷԴ)
	this->_AddToContextList( pNewSocketContext );

	////////////////////////////////////////////////////////////////////////////////////////////////
	// 5. ʹ֮󣬰Listen SocketǸIoContextãȻ׼ͶµAcceptEx
	pIoContext->ResetBuffer();
	return this->_PostAccept( pIoContext ); 	
}

////////////////////////////////////////////////////////////////////
// Ͷݽ
bool CSATTCPServer::_PostRecv( PER_IO_CONTEXT* pIoContext )
{
	// ʼ
	DWORD dwFlags = 0;
	DWORD dwBytes = 0;
	WSABUF *p_wbuf   = &pIoContext->m_wsaBuf;
	OVERLAPPED *p_ol = &pIoContext->m_Overlapped;

	pIoContext->ResetBuffer();
	pIoContext->m_OpType = RECV_POSTED;

	// ʼɺ󣬣ͶWSARecv
	int nBytesRecv = WSARecv( pIoContext->m_sockAccept, p_wbuf, 1, &dwBytes, &dwFlags, p_ol, NULL );

	// ֵ󣬲ҴĴ벢PendingĻǾ˵صʧ
	if ((SOCKET_ERROR == nBytesRecv) && (WSA_IO_PENDING != WSAGetLastError()))
	{
		this->_ShowMessage(_T("ͶݵһWSARecvʧܣ"));
		return false;
	}
	return true;
}

/////////////////////////////////////////////////////////////////
// нյݵʱ򣬽д
bool CSATTCPServer::_DoRecv( PER_SOCKET_CONTEXT* pSocketContext, PER_IO_CONTEXT* pIoContext )
{
	// Ȱһεʾ֣Ȼ״̬һRecv
	SOCKADDR_IN* ClientAddr = &pSocketContext->m_ClientAddr;
	//this->_ShowMessage( _T("յ  %s:%d Ϣ%s"),inet_ntoa(ClientAddr->sin_addr), ntohs(ClientAddr->sin_port), pIoContext->m_wsaBuf.buf );
	
	_RecvProcess(pSocketContext, pIoContext);

	// ȻʼͶһWSARecv
	return _PostRecv( pIoContext );
}



/////////////////////////////////////////////////////
// (Socket)󶨵ɶ˿
bool CSATTCPServer::_AssociateWithIOCP( PER_SOCKET_CONTEXT *pContext )
{
	// ںͿͻͨŵSOCKET󶨵ɶ˿
	HANDLE hTemp = CreateIoCompletionPort((HANDLE)pContext->m_Socket, m_hIOCompletionPort, (DWORD)pContext, 0);

	if (NULL == hTemp)
	{
		this->_ShowMessage(_T("ִCreateIoCompletionPort()ִ.룺%d"),GetLastError());
		return false;
	}

	return true;
}


//====================================================================================
//
//				    ContextList ز
//
//====================================================================================

//////////////////////////////////////////////////////////////
// ͻ˵Ϣ洢
void CSATTCPServer::_AddToContextList( PER_SOCKET_CONTEXT *pHandleData )
{
	EnterCriticalSection(&m_csContextList);

	m_arrayClientContext.Add(pHandleData);	
	
	LeaveCriticalSection(&m_csContextList);
}

////////////////////////////////////////////////////////////////
//	ƳĳضContext
void CSATTCPServer::_RemoveContext( PER_SOCKET_CONTEXT *pSocketContext )
{
	EnterCriticalSection(&m_csContextList);

	for( int i=0;i<m_arrayClientContext.GetCount();i++ )
	{
		if( pSocketContext==m_arrayClientContext.GetAt(i) )
		{
			RELEASE( pSocketContext );			
			m_arrayClientContext.RemoveAt(i);			
			break;
		}
	}

	LeaveCriticalSection(&m_csContextList);
}

////////////////////////////////////////////////////////////////
// տͻϢ
void CSATTCPServer::_ClearContextList()
{
	EnterCriticalSection(&m_csContextList);

	for( int i=0;i<m_arrayClientContext.GetCount();i++ )
	{
		delete m_arrayClientContext.GetAt(i);
	}

	m_arrayClientContext.RemoveAll();

	LeaveCriticalSection(&m_csContextList);
}



//====================================================================================
//
//				       
//
//====================================================================================

////////////////////////////////////////////////////////////////////
// ñIPַ
CString CSATTCPServer::GetLocalIP()
{
	// ñ
	char hostname[MAX_PATH] = {0};
	gethostname(hostname,MAX_PATH);                
	struct hostent FAR* lpHostEnt = gethostbyname(hostname);
	if(lpHostEnt == NULL)
	{
		return DEFAULT_IP;
	}

	// ȡIPַбеĵһΪصIP(Ϊһ̨ܻ󶨶IP)
	LPSTR lpAddr = lpHostEnt->h_addr_list[0];      

	// IPַתַʽ
	struct in_addr inAddr;
	memmove(&inAddr,lpAddr,4);
	m_strIP = CString( inet_ntoa(inAddr) );        

	return m_strIP;
}

///////////////////////////////////////////////////////////////////
// ñд
int CSATTCPServer::_GetNoOfProcessors()
{
	SYSTEM_INFO si;

	GetSystemInfo(&si);

	return si.dwNumberOfProcessors;
}

/////////////////////////////////////////////////////////////////////
// ʾʾϢ
void CSATTCPServer::_ShowMessage(const CString szFormat,...) const
{
	// ݴĲʽַ
	CString   strMessage;
	va_list   arglist;

	// 䳤
	va_start(arglist, szFormat);
	strMessage.FormatV(szFormat,arglist);
	va_end(arglist);

	Global::WriteTextLog(strMessage);
}

#define PAK_LEN sizeof(SATProtocol::DataHeader)
void CSATTCPServer::_RecvProcess(PER_SOCKET_CONTEXT* pSocketContext, PER_IO_CONTEXT* pIoContext)
{
#ifdef _DEBUG
	OutputDebugString("ݷ\n");
#endif
	Global::WriteTextLog("ݷ");
	// Сڰͷ;
	SATProtocol::DataHeader* phead = NULL;
	if (pSocketContext->lastData.size() == 0)
	{
		// ͷ;
		if (PAK_LEN > pIoContext->m_Overlapped.InternalHigh)
		{
			OutputDebugString("Aͷ;\n");
			Global::WriteTextLog("Aͷ");
			pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf, pIoContext->m_Overlapped.InternalHigh);
		}
		else
		{
			// ͷ;
			phead = (SATProtocol::DataHeader*)pIoContext->m_wsaBuf.buf;
			if ( !CheckDataHeader(phead) )
			{
				OutputDebugString("Aͷ;\n");
				Global::WriteTextLog("Aͷ");
				return;
			}

			// İ;
			if (phead->len == pIoContext->m_Overlapped.InternalHigh)
			{
				OutputDebugString("Aİ;\n");
				Global::WriteTextLog("Aİ");
				_TaskProcess(pIoContext, (SATProtocol::Package*)pIoContext->m_wsaBuf.buf);
			}
			// С;
			else if (phead->len > pIoContext->m_Overlapped.InternalHigh)
			{
				OutputDebugString("AС;\n");
				Global::WriteTextLog("AС");
				pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf, pIoContext->m_Overlapped.InternalHigh);
			}
			// ;
			else if (phead->len < pIoContext->m_Overlapped.InternalHigh)
			{
				OutputDebugString("A;\n");
				Global::WriteTextLog("A");
				pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf + phead->len, pIoContext->m_Overlapped.InternalHigh - phead->len);
				_TaskProcess(pIoContext, (SATProtocol::Package*)pIoContext->m_wsaBuf.buf);
			}
		}
	}
	else
	{
		int lastlen = pIoContext->m_Overlapped.InternalHigh;
		if (pSocketContext->lastData.size() >= PAK_LEN)
		{
			phead = (SATProtocol::DataHeader*)pSocketContext->lastData.data();
			if ( !CheckDataHeader(phead) )
			{
				OutputDebugString("Cͷ;\n");
				Global::WriteTextLog("Cͷ");
				pSocketContext->lastData.clear();
				return;
			}

			if (phead->len <= pSocketContext->lastData.size() + pIoContext->m_Overlapped.InternalHigh)
			{
				if ( phead->len <= pSocketContext->lastData.size() )
				{
					OutputDebugString("C;\n");
					Global::WriteTextLog("C");
					// ;
					_TaskProcess(pIoContext, (SATProtocol::Package*)pSocketContext->lastData.substr(0, phead->len).data());

					pSocketContext->lastData = pSocketContext->lastData.substr(phead->len);
					pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf, pIoContext->m_Overlapped.InternalHigh);
				}
				else
				{
					OutputDebugString("D;\n");
					Global::WriteTextLog("D");
					lastlen = pSocketContext->lastData.size() + pIoContext->m_Overlapped.InternalHigh - phead->len;
					pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf, pIoContext->m_Overlapped.InternalHigh - lastlen);
					// ;
					_TaskProcess(pIoContext, (SATProtocol::Package*)pSocketContext->lastData.data());
					// ʣ;
					pSocketContext->lastData.clear();
					if (lastlen)
						pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf + pIoContext->m_Overlapped.InternalHigh - lastlen, lastlen);
				}
			}
			else
			{
				OutputDebugString("CԲһ;\n");
				Global::WriteTextLog("CԲһ");
				pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf, pIoContext->m_Overlapped.InternalHigh);
			}
		}
		else
		{
			// ͷʣ೤;
			int diflen = PAK_LEN - pSocketContext->lastData.size();
			// Բһͷ;
			if ( diflen > pIoContext->m_Overlapped.InternalHigh )
			{
				OutputDebugString("BԲһͷ;\n");
				Global::WriteTextLog("BԲһͷ");
				pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf, pIoContext->m_Overlapped.InternalHigh);
			}
			else
			{
				// ƴͷ;
				pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf, diflen);
				phead = (SATProtocol::DataHeader*)pSocketContext->lastData.data();
				if ( !CheckDataHeader(phead) )
				{
					OutputDebugString("Bͷ;\n");
					Global::WriteTextLog("Bͷ");
					pSocketContext->lastData.clear();
					return;
				}

				// ;
				if ( phead->len == PAK_LEN + pIoContext->m_Overlapped.InternalHigh - diflen )
				{
					OutputDebugString("B;\n");
					Global::WriteTextLog("B");
					pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf + diflen, pIoContext->m_Overlapped.InternalHigh - diflen);
					_TaskProcess(pIoContext, (SATProtocol::Package*)pSocketContext->lastData.data());
					pSocketContext->lastData.clear();
				}
				// С;
				else if ( phead->len > PAK_LEN + pIoContext->m_Overlapped.InternalHigh - diflen)
				{
					OutputDebugString("BС;\n");
					Global::WriteTextLog("BС");
					pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf + diflen, pIoContext->m_Overlapped.InternalHigh - diflen);
				}
				// ;
				else if (phead->len < PAK_LEN + pIoContext->m_Overlapped.InternalHigh - diflen)
				{
					OutputDebugString("B;\n");
					Global::WriteTextLog("B");
					// ɰ;
					pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf + diflen, phead->len - PAK_LEN);
					_TaskProcess(pIoContext, (SATProtocol::Package*)pSocketContext->lastData.data());
					pSocketContext->lastData.clear();
					int last = pIoContext->m_Overlapped.InternalHigh - diflen - phead->len + PAK_LEN;
					if (last)
					{						
						pSocketContext->lastData.append(pIoContext->m_wsaBuf.buf + pIoContext->m_Overlapped.InternalHigh - last, last);
					}
				}
			}
		}
	}
}

void CSATTCPServer::_TaskProcess(PER_IO_CONTEXT* pIoContext, SATProtocol::Package* pak)
{
#ifdef _DEBUG
	OutputDebugString("\n########ɹȡ########\n\n");
#endif
	Global::WriteTextLog("ɹȡ");

	SATProtocol::DataHeader *pHeader = &pak->header;
	if ( !pHeader ) 
		return;

	if ( pHeader->protocol == 0xAA ) {
		switch ( pHeader->cmd  ) 
		{
			case SATProtocol::CMD_LOGIN:
			case SATProtocol::CMD_LOGOUT:
				{
					// ¼;
					SATProtocol::UserInfo *pLogin = (SATProtocol::UserInfo*)pak->buf;
					Global::WriteTextLog(_T("User=%s, psw=%s"), pLogin->szUserName, pLogin->szPassword);
					bool bRet = CSATExecutor::GetInstance()->Login(pLogin->szUserName, pLogin->szPassword, pLogin->szActuatorName, !pHeader->cmd);

					// ݰ;
					long len = sizeof(SATProtocol::DataHeader)+sizeof(SATProtocol::LoginResp);
					byte *pbuff = new byte[len];
					memset(pbuff, 0, len);
					SATProtocol::Package *pSendPak = (SATProtocol::Package *)pbuff;
					pSendPak->header.protocol = 0xAA;
					pSendPak->header.cmd = pHeader->cmd;
					pSendPak->header.len = len;
#if 0
					// ݵָ;
					memcpy(pSendPak->buf, &bRet, sizeof(bool));

					char szMessage[MAX_PATH] = {0};
					_stprintf_s(szMessage, _T("¼"));
					memcpy(pSendPak->buf + sizeof(bool), szMessage, MAX_PATH);
#else
					const SATParameters::STLoginResp *pstLoginResp = CSATExecutor::GetInstance()->GetLoginResp();
					SATProtocol::LoginResp *pLoginResp = (SATProtocol::LoginResp*)(pbuff+sizeof(SATProtocol::DataHeader));
					pLoginResp->bStatus = bRet;
					memset(pLoginResp->szMessage, 0, MAX_PATH);
					//_stprintf_s(pLoginResp->szMessage, _T("%s"), pstLoginResp->strMessage.c_str());
					//_tcscpy_s(pLoginResp->szMessage, _T("¼"));
					// ʹϷַʽֵ,ᵼ'\0'ֽڲΪ0;
					memcpy(pLoginResp->szMessage, pstLoginResp->strMessage.c_str(), pstLoginResp->strMessage.size());
#endif
					// ,жǷͳɹ;
					send(pIoContext->m_sockAccept, (const char*)pbuff, len, 0);

					// ͷڴ;
					delete []pbuff;
					pbuff = NULL;
				}
				break;
			case SATProtocol::CMD_ADD_DEVICE:
			case SATProtocol::CMD_DEL_DEVICE:
				{
					std::string ip = (char*)pak->buf;
					if (pHeader->cmd == SATProtocol::CMD_DEL_DEVICE ) 
						CSATDevices::DelDevices(ip);
					else 
						CSATDevices::AddReticleDevices(ip);

					SATProtocol::DataHeader header;
					header.cmd = pHeader->cmd;
					header.len = sizeof(SATProtocol::DataHeader);
					header.protocol = 0xAA;

					send(pIoContext->m_sockAccept, (const char*)&header, sizeof(SATProtocol::DataHeader), 0);
				}
				break;
			case SATProtocol::CMD_QUERY_DEVICES:
				{
					// ݰ;
					long len = sizeof(SATProtocol::DataHeader)+sizeof(SATProtocol::LoginResp);
					byte *pbuff = new byte[len];
					memset(pbuff, 0, len);
					SATProtocol::Package *pSendPak = (SATProtocol::Package *)pbuff;
					pSendPak->header.protocol = 0xAA;
					pSendPak->header.cmd = pHeader->cmd;
					pSendPak->header.len = len;
					// תpak->bufΪṹ;
					SATProtocol::DeviceResp *pDevResp = (SATProtocol::DeviceResp*)(pbuff+sizeof(SATProtocol::DataHeader));
					memset(pDevResp->szDevs, 0, 30*MAX_PATH);
					// ȡ豸б;
					pDevResp->nSize = CSATDevices::AttachDeviceName2Buffer(pDevResp->szDevs);

					// ظͻ;
					send(pIoContext->m_sockAccept, (const char*)pbuff, len, 0);

					// ͷڴ;
					delete []pbuff;
					pbuff = NULL;
				}
				break;
			default:
				break;
		}
	}
}

bool CSATTCPServer::CheckDataHeader(SATProtocol::DataHeader* header)
{
	if ( header->protocol != 0xAA )
		return false;

	return true;
}

/////////////////////////////////////////////////////////////////////
// жϿͻSocketǷѾϿһЧSocketͶWSARecv쳣
// ʹõķǳsocketݣжsocketõķֵ
// Ϊͻ쳣Ͽ(ͻ˱߰εߵ)ʱ򣬷޷յͻ˶Ͽ֪ͨ

bool CSATTCPServer::_IsSocketAlive(SOCKET s)
{
	int nByteSent=send(s,"",0,0);
	if (-1 == nByteSent) return false;
	return true;
}

///////////////////////////////////////////////////////////////////
// ʾɶ˿ϵĴ
bool CSATTCPServer::HandleError( PER_SOCKET_CONTEXT *pContext,const DWORD& dwErr )
{
	// ǳʱˣټȰ  
	if(WAIT_TIMEOUT == dwErr)  
	{  	
		// ȷϿͻǷ񻹻...
		if( !_IsSocketAlive( pContext->m_Socket) )
		{
			this->_ShowMessage( _T("⵽ͻ쳣˳") );
			this->_RemoveContext( pContext );
			return true;
		}
		else
		{
			this->_ShowMessage( _T("ʱ...") );
			return true;
		}
	}  

	// ǿͻ쳣˳
	else if( ERROR_NETNAME_DELETED==dwErr )
	{
		this->_ShowMessage( _T("⵽ͻ쳣˳") );
		this->_RemoveContext( pContext );
		return true;
	}

	else
	{
		this->_ShowMessage( _T("ɶ˿ڲִ߳˳룺%d"),dwErr );
		return false;
	}
}




