#ifndef __WINDOWS_SERVICE__
#define __WINDOWS_SERVICE__

#include <WinSvc.h>

namespace WindowsService
{
	// ص;
	typedef void (CALLBACK *WorkStartCallback)();
	// ص;
	typedef void (CALLBACK *WorkEndofCallback)();

	//////////////////////////////////////////////////////////////////////////
	// ȫֱ;
	//////////////////////////////////////////////////////////////////////////
	extern SERVICE_STATUS_HANDLE	g_SvcStatusHandle;
	extern SERVICE_STATUS			g_SvcStatus;
	extern HANDLE					g_hCtrlSvc;							
	extern TCHAR					g_szlpSvrDescription[MAX_PATH] ;
	extern TCHAR					g_szSvcName[MAX_PATH];
	extern WorkStartCallback		g_lpStartWorkCallBack;
	extern WorkEndofCallback		g_lpEndofWorkCallBack;
	//////////////////////////////////////////////////////////////////////////
	// ȫֺ;
	// ʼ;
	extern void InitSvcVar();
	// ǷѰװ;
	extern BOOL IsSvcInstalled();
	// װ;
	extern BOOL SvcInstall();
	// windowsں;
	extern void WINAPI ServiceMain();
	// windows״̬;
	extern void WINAPI SvcCtrlHandler(IN DWORD dwControlCode);
	// ʼSOCKET;
	extern int InitWinSock();
	// ־¼;
	extern void SvcReportEvent(IN LPCTSTR pFormat, ...);
	// SCM״̬;
	extern BOOL ReportSvcStatus(
		IN DWORD dwCurrentState, 
		IN DWORD dwWin32ExitCode,
		IN DWORD dwServiceSpecificExitCode, 
		IN DWORD dwCheckPoint, 
		IN DWORD dwWaitHint);

	// ָķ;
	extern void StartSvc(IN LPCTSTR lpSvcName);
	extern void UpdateSvcDacl(IN LPCTSTR lpSvcName);
	extern void DoStopSvc(IN LPCTSTR lpSvcName);
	extern BOOL StopDependentServices();
	// ѯ״̬;
	extern void DoQuerySvc(IN LPCTSTR lpSvcName);
	// ·;
	extern void DoUpdateSvcDesc(IN LPCTSTR lpSvcName);
	extern void DoDisableSvc(IN LPCTSTR lpSvcName);
	extern void DoEnableSvc(IN LPCTSTR lpSvcName);
	extern void DoDeleteSvc(IN LPCTSTR lpSvcName);
	extern void KillService();
	// ûصָ;
	extern void SetCallBack( IN LPVOID lpStartWorkCallBack, IN LPVOID lpEndofWorkCallBack );
	// ڷⲿexe;
	extern BOOL StartProcess( IN LPCTSTR lpExePath );
	//
	extern BOOL GetTokenByName( IN HANDLE &hToken, IN LPCTSTR lpName);
	//
	extern BOOL GetDebugPriv();
	//
	extern DWORD GetExplorerToken(OUT HANDLE* phExplorerToken);
};


#endif