﻿// pch.h: 这是预编译标头文件。
// 下方列出的文件仅编译一次，提高了将来生成的生成性能。
// 这还将影响 IntelliSense 性能，包括代码完成和许多代码浏览功能。
// 但是，如果此处列出的文件中的任何一个在生成之间有更新，它们全部都将被重新编译。
// 请勿在此处添加要频繁更新的文件，这将使得性能优势无效。

#ifndef PCH_H
#define PCH_H

// 添加要在此处预编译的标头
#include "framework.h"

#include <thread>
#include <future>               // std::async, std::future
#include <chrono>   
#include <mutex>
#include <condition_variable>
using namespace std;
using namespace chrono;

// 启停停靠窗口;
#define __DOCKINGBAR__ 1
// 启停导航栏;
#define __OUTLOOKBAR__ 0
// 启停标题栏;
#define __CAPTIONBAR__ 0
// 快速访问工具栏
#define __QUICKACCESS_COMMAND__ 0
// 输出窗口;
#define __OUT_PUT_WIN__ 0
// 文件、类窗口
#define __FC_WIN__ 0
// Pane使用对话框;
#define __PANE_DLG__ 0

//////////////////////////////////////////////////////////////////////////
// START;
#include <VFW.H>
//#include "AMESDK.H"
#include "QCAP.H"
#define FREE( p ) { if( p ) { free( p ); p = NULL; } }	

// SET INITIAL PARAMETER VALUES
// CY3014 USB
#define	SC_DEFAULT_STANDARD                 0		// 0 = NTSC / 1 = PALB
#define SC_DEFAULT_INPUT_SUPPORT			0x00000000	// HDMI
#define DEFAULT_PRODUCT						"StreamCatcher QCAP - UB658G"
#define DEFAULT_PRODUCT_VERSION				""
// END
//////////////////////////////////////////////////////////////////////////
#include <string>
#include <map>
#include "Global.h"
#include <afxcontrolbars.h>
#include "tinyxml2.h"
#include "cJSON.h"
#include "Device.h"
#endif //PCH_H
