/************************************************************************/
/*  Copyright (C), 2016-2020, [Home], Ȩ;
/*  ģ  ͬģ;
/*      ;
/*
/*      [V];
/*      ߣ[Home];
/*      ڣ[12/20/2017];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[Home];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/

#ifndef __SYN_SERIAL__
#define __SYN_SERIAL__

#pragma once

#define MAX_PORT_LEN 10

class CSynSerial
{
public:
	CSynSerial(void);
	virtual ~CSynSerial(void);

private:
	DCB		m_dcb;
	HANDLE	m_hSerialPort;
	COMMTIMEOUTS	m_cts;

	// ں(1~255);
	TCHAR	m_szSerialPort[MAX_PORT_LEN];
	// 뻺С(byte);
	DWORD	m_dwInQueue;
	// С(byte);
	DWORD	m_dwOutQueue;

public:
	inline BOOL IsOpen() const {
		return (m_hSerialPort == NULL || m_hSerialPort == INVALID_HANDLE_VALUE) ? FALSE : TRUE;
	}

	// 򿪴;
	BOOL OpenSerialPort(
		IN BYTE byCommPort,		// ں;
		IN DWORD dwBaudRate,		// ;
		IN BYTE bySize,			// λ;
		IN BYTE byParity,		// Уλ;
		IN BYTE byStopBits,		// ֹͣλ;
		IN BYTE byStartAddr,		// ʼַ;
		IN INT nInterval			// ʱ;
	);

	BOOL OpenSerialPort(
		IN LPCTSTR lpCommPort,		// ں;
		IN DWORD dwBaudRate,		// ;
		IN BYTE bySize,			// λ;
		IN BYTE byParity,		// Уλ;
		IN BYTE byStopBits,		// ֹͣλ;
		IN BYTE byStartAddr,		// ʼַ;
		IN INT nInterval			// ʱ;
		);

	// װ򿪴;
	BOOL ReOpenSerialPort();
	// رմ;
	void CloseSerialPort();
	// ôڲ;
	BOOL SetSerialPort(
		IN CONST DWORD& dwBaudRate,		// ;
		IN CONST BYTE& byByteSize,		// λ;
		IN CONST BYTE& byParity,		// Уλ;
		IN CONST BYTE& byStopBits,		// ֹͣλ;
		IN CONST BYTE& byStartAddr,		// ʼַ;
		IN CONST DWORD& dwInQueue,		// 뻺;
		IN CONST DWORD& dwOutQueue		// ;
		);

	// dcb;
	void SetSerialDCB(IN CONST DCB &dcb);
	// commtimeouts;
	void SetSerialCommTimeouts(IN CONST COMMTIMEOUTS &commTimeouts);

	virtual DWORD WriteComm(IN BYTE *pWirteBuf, IN CONST INT32 nWriteSize);
	virtual DWORD ReadComm(IN BYTE *pReadBuf, IN CONST DWORD& dwReadSize, WORD timeout = 300);
};

#endif // __SYN_SERIAL__