﻿// DlgService.cpp: 实现文件
//

#include "stdafx.h"
#include "SATHelper.h"
#include "DlgService.h"
#include "afxdialogex.h"


// CDlgService 对话框

IMPLEMENT_DYNAMIC(CDlgService, CDialogEx)

CDlgService::CDlgService(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_DLG_SERVICE, pParent)
{

}

CDlgService::~CDlgService()
{
}

void CDlgService::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_DEVICES, m_listDevices);
	DDX_Control(pDX, IDC_LIST_TASK, m_listTask);
}


BEGIN_MESSAGE_MAP(CDlgService, CDialogEx)
	ON_WM_PAINT()
	ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


// CDlgService 消息处理程序


BOOL CDlgService::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  在此添加额外的初始化
	// 做为子窗口，这里设置透明度没有任何效果;
	// SetLayeredWindowAttributes(RGB(1, 2, 3), 0, LWA_COLORKEY/*|LWA_ALPHA*/);
	InitCtrl();
	return TRUE;  // return TRUE unless you set the focus to a control
				  // 异常: OCX 属性页应返回 FALSE
}


void CDlgService::OnPaint()
{
	CPaintDC dc(this); // device context for painting
					   // TODO: 在此处添加消息处理程序代码
					   // 不为绘图消息调用 CDialogEx::OnPaint()
	CRect rc;
	GetClientRect(rc);
	CBrush   brush;
	brush.CreateSolidBrush(0xFFEFD5);
	dc.FillRect(&rc, &brush);
}


HBRUSH CDlgService::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialogEx::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO:  在此更改 DC 的任何特性
	if (nCtlColor == CTLCOLOR_STATIC)
	{
		pDC->SetBkMode(TRANSPARENT);//设置背景透明
		//pDC->SetTextColor(RGB(255, 255, 0));//设置字体为黄色
		return (HBRUSH)::GetStockObject(NULL_BRUSH);
	}
	// TODO:  如果默认的不是所需画笔，则返回另一个画笔
	return hbr;
}

void CDlgService::InitCtrl()
{
	// 初始化设备列表;
	m_listDevices.InsertColumn(0, "No");
	m_listDevices.SetColumnWidth(0, 25);
	m_listDevices.InsertColumn(1, "类型");
	m_listDevices.SetColumnWidth(1, 55);
	m_listDevices.InsertColumn(2, "名称");
	m_listDevices.SetColumnWidth(2, 140);
	m_listDevices.InsertColumn(3, "状态");
	m_listDevices.SetColumnWidth(3, 55);

	// 初始化任务列表;
	m_listTask.InsertColumn(0, "No");
	m_listTask.SetColumnWidth(0, 25);
	m_listTask.InsertColumn(1, "任务ID");
	m_listTask.SetColumnWidth(1, 130);
	m_listTask.InsertColumn(2, "状态");
	m_listTask.SetColumnWidth(2, 55);
	m_listTask.InsertColumn(3, "结果");
	m_listTask.SetColumnWidth(3, 55);
}
