#ifndef _ZEROT_TRAYICON_H
#define _ZEROT_TRAYICON_H

////////////////
#define MYWM_SHOWMINBOX WM_USER + 2  // ԶϢ,ʾԻ;


class ITrayIcon : public CCmdTarget 
{
protected:
	DECLARE_DYNAMIC(ITrayIcon)
	NOTIFYICONDATA m_nid;			// struct for Shell_NotifyIcon args

public:
	ITrayIcon(UINT uID);
	~ITrayIcon();

	// Call this to receive tray notifications
	void SetNotificationWnd(CWnd* pNotifyWnd, UINT uCbMsg);

	// SetIcon functions. To remove icon, call SetIcon(0)
	BOOL SetIcon(UINT uID); // only set the icon,but without tip zt.
	BOOL SetIcon(HICON hicon, LPCTSTR lpTip);
	BOOL SetIcon(UINT uID, LPCTSTR lpTip);
	BOOL SetIcon(LPCTSTR lpResName, LPCTSTR lpTip)
	{ 
		return SetIcon(lpResName ? 	AfxGetApp()->LoadIcon(lpResName) : NULL, lpTip); 
	}

	// ʾ(ʾʱ,ǷҲҪͬʱͼ???);
	BOOL SetTip(LPCTSTR lpTip);
	BOOL SetTipTitle(LPCTSTR lpTipTitle);
	//BOOL SetInfo(LPCSTR lpInfo,LPCSTR lpInfoTitle = _T(""));	// NIF_INFO
	BOOL SetInfo(LPCTSTR lpInfo, LPCTSTR lpInfoTitle = NULL);	// NIF_INFO

	BOOL SetStandardIcon(LPCTSTR lpszIconName, LPCTSTR lpTip)
	{ 
		return SetIcon(::LoadIcon(NULL, lpszIconName), lpTip); 
	}

	virtual LRESULT OnTrayNotification(WPARAM uID, LPARAM lEvent);

	// -------------------------------˸ʵ------------------------------- [5/30/2013 Z.t]
public:
	bool IsFlashing(){return bSuspending;}						// ⲿ,жǷ˸;
	void SetMiniShow(BOOL bSet){bShowMinibox = bSet;}

	BOOL StartFlashing();
	BOOL StopFlashing();
	inline void SetIconInfos(const UINT &u1,const UINT &u2,const UINT &u3);
	inline void SetDefaultTip(LPCTSTR lpTip){_lpTip=lpTip;}
protected:
	bool bSuspending;			// ߳бʶ;
	
	LPCTSTR _lpTip;				// Ĭϵʾ;
	UINT _utIcon[3];			// 1.ֹͣ˸ʱĬͼ;2.˸ʱıͼ;3.˸ʱﱳͼ;

	DWORD  m_dwThreadID;		// ߳ID; 
	HANDLE m_hThreadCtrl;		// ߳̿ؼ¼;
	HANDLE m_hThreadObj;		// ̱߳;

	BOOL bShowMinibox;			// ˸ڼ,ǷԴڷϢ;
	void GetTrayRect(RECT &rc);
	BOOL IsWow64();

	// ˸߳;
	int OpendThread();
	void TerminalThread();
	static DWORD WINAPI FlashingThread(LPVOID pVoid);

};

inline void ITrayIcon::SetIconInfos(const UINT &u1,const UINT &u2,const UINT &u3)
{
	_utIcon[0] = u1;
	_utIcon[1] = u2;
	_utIcon[2] = u3;
}

#endif

// δBUG:
// 1.н,ͼδ;
// SetIcon(0)ͼ(NIF_DELETE);
