#include "stdafx.h"
#include "WindowService.h"
#include <psapi.h>
#include <tlhelp32.h>
#pragma comment ( lib, "psapi.lib" )
#include <Aclapi.h>
#include <strsafe.h>
#include <shlwapi.h>

namespace WindowsService
{
	//////////////////////////////////////////////////////////////////////////
	// ȫֱ;
	//////////////////////////////////////////////////////////////////////////
	SERVICE_STATUS_HANDLE	g_SvcStatusHandle;							// ;
	SERVICE_STATUS			g_SvcStatus;								// ״̬;
	HANDLE					g_hCtrlSvc = NULL;							// ¼;												
	TCHAR					g_szlpSvrDescription[MAX_PATH] = _T("");	// 	;
	TCHAR					g_szSvcName[MAX_PATH] = _T("");				// ;
	WorkStartCallback		g_lpStartWorkCallBack = NULL;				// ;
	WorkEndofCallback		g_lpEndofWorkCallBack = NULL;				// ;

	//////////////////////////////////////////////////////////////////////////
	// ȫֺ;
	int InitWinSock()
	{
		WORD	wVersionRequested;	
		WSADATA	wsaData;			
		int		nErrCode;			

		wVersionRequested = MAKEWORD(2, 2);	
		nErrCode = WSAStartup( wVersionRequested, &wsaData );
		if ( 0 != nErrCode ) 
			return -1;

		return 0;
	}

	/************************************************************************/
	/*  InitSvcVar;
	/*  ʼ;
	/*  ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void InitSvcVar()
	{
		g_SvcStatusHandle = NULL;
		g_SvcStatus.dwServiceType = SERVICE_WIN32_SHARE_PROCESS | SERVICE_INTERACTIVE_PROCESS; // | SERVICE_INTERACTIVE_PROCESS潻;
		g_SvcStatus.dwCurrentState = SERVICE_STOPPED;
		g_SvcStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP;
		g_SvcStatus.dwWin32ExitCode = 0;
		g_SvcStatus.dwServiceSpecificExitCode = 0;
		g_SvcStatus.dwCheckPoint = 0;
		g_SvcStatus.dwWaitHint = 0;
	}

	/************************************************************************/
	/*  IsSvcInstalled;
	/*  жϷǷװ;
	/*  ;
	/*  أѰװTRUE,򷵻FALSE;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	BOOL IsSvcInstalled()
	{
		BOOL bResult = FALSE;
		// 򿪷ƹ;
		SC_HANDLE schSCM = ::OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

		if (schSCM != NULL)
		{// 򿪷;
			SC_HANDLE schSvc = ::OpenService(schSCM, g_szSvcName, SERVICE_QUERY_CONFIG);
			if (schSvc != NULL)
			{
				bResult = TRUE;
				::CloseServiceHandle(schSvc);
			}
			::CloseServiceHandle(schSCM);
		}

		return bResult;
	}

	/************************************************************************/
	/*  SvcInstall;
	/*  װ;
	/*  ;
	/*  أװɹTRUE,򷵻FALSE;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	BOOL SvcInstall()
	{
		// ȡľ·;
		TCHAR szFilePath[MAX_PATH];
		if ( 0 == ::GetModuleFileName(NULL, szFilePath, MAX_PATH) )
		{
			_tprintf_s(_T("Cannot Install Service (%d)\n"), GetLastError());
			return FALSE;
		}

		// 򿪷ƹ,ȡSCMݿ;
		SC_HANDLE schSCM = ::OpenSCManager(
			NULL,						// ؼ;
			NULL,						// ServicesActive database;
			SC_MANAGER_ALL_ACCESS		// Ȩ;
			);

		if (schSCM == NULL)
		{
			_tprintf_s(_T("OpenSCManager failed (%d)\n"), GetLastError());
			return FALSE;
		}

		// ;
		SC_HANDLE schSvc = ::CreateService(
			schSCM,							// SCMݿ;
			g_szSvcName,					// ;
			g_szSvcName,					// ;
			SERVICE_ALL_ACCESS,				// ҪķȨ;
			SERVICE_WIN32_OWN_PROCESS | SERVICE_INTERACTIVE_PROCESS,		// ;
			SERVICE_AUTO_START, //SERVICE_DEMAND_START,		// ;
			SERVICE_ERROR_NORMAL,			// ;
			szFilePath,						// ·;
			NULL,							// ޼˳;
			NULL,							// ޱǩʶ;
			_T(""),							// ;
			NULL,							// ϵͳ˺;
			NULL							// (no password);
			);

		if ( schSvc == NULL )
		{
			_tprintf_s(_T("CreateService failed (%d)\n"), GetLastError());
			CloseServiceHandle(schSvc);
			return FALSE;
		}

		// ÷;
		SERVICE_DESCRIPTION ServiceDesc;    
		ServiceDesc.lpDescription  =  g_szlpSvrDescription;   
		::ChangeServiceConfig2(schSvc,   SERVICE_CONFIG_DESCRIPTION,   &ServiceDesc);   

		// ͷԴ;
		::CloseServiceHandle(schSvc);
		::CloseServiceHandle(schSCM);

		return TRUE;
	}

	/************************************************************************/
	/*  ServiceMain;
	/*  ں;
	/*  ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void WINAPI ServiceMain()
	{
		// עĿƺ;
		g_SvcStatusHandle = RegisterServiceCtrlHandler(g_szSvcName, SvcCtrlHandler);
		if (g_SvcStatusHandle == NULL)
		{
			SvcReportEvent(_T("Handler not installed"));
			return;
		}

		// ÷״̬;
		g_SvcStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
		g_SvcStatus.dwServiceSpecificExitCode = 0;

		// עɹSCM״̬Ϣ,Ϊûʼ;
		// Եǰ״̬ΪSERVICE_START_PENDING ;
		ReportSvcStatus(SERVICE_START_PENDING, NO_ERROR, 0, 1, 3000); // һ¼ԼҪ3;

		//////////////////////////////////////////////////////////////////////////
		// ʼʼ;
		g_hCtrlSvc = ::CreateEvent(	NULL,TRUE, FALSE, _T("CtrlService::g_hCtrlSvc"));
		if (g_hCtrlSvc == NULL)
		{
			// SCMֹͣ;
			ReportSvcStatus(SERVICE_STOPPED, NO_ERROR, 0, 1, 0);
			return;
		}

		// SCM;
		ReportSvcStatus( SERVICE_RUNNING, NO_ERROR, 0, 0, 0);

		// ;
		if ( g_lpStartWorkCallBack )
			g_lpStartWorkCallBack();

		// ߳еĴн󷵻ServiceMain(),
		// ServiceMain()WaitForSingleObject,
		// Ϊֹ֮ͣǰServiceMain() 
		WaitForSingleObject(g_hCtrlSvc,INFINITE); // INFINITEʾ޵ȴ,ȴSCMź;
		CloseHandle(g_hCtrlSvc);

		// ;
		if ( g_lpEndofWorkCallBack )
			g_lpEndofWorkCallBack();

		SvcReportEvent(_T("Service stopped"));

		// SCMֹͣ;
		ReportSvcStatus(SERVICE_STOPPED,NO_ERROR,0,0,0); 
	}

	/************************************************************************/
	/*  SvcCtrlHandler;
	/*  ÿп뷢͸ʱSCM;
	/*  ;
	/*  	[IN] dwControlCode͸Ŀ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void WINAPI SvcCtrlHandler(IN DWORD dwControlCode)
	{
		BOOL bsucc = FALSE;
		switch (dwControlCode)
		{
		case SERVICE_CONTROL_SHUTDOWN:		// ص;
		case SERVICE_CONTROL_STOP:			// ֹͣ;
			bsucc = ReportSvcStatus(SERVICE_STOP_PENDING, NO_ERROR, 0, 1, 0);
			if (bsucc)
				KillService();
			break;
		case SERVICE_CONTROL_PAUSE:
			// ͣ;
			break;
		case SERVICE_CONTROL_CONTINUE:
			// ָͣķ;
			break;
		case SERVICE_CONTROL_INTERROGATE:
			break;
		default:
			SvcReportEvent(_T("Bad service request"));
		}
	}

	/************************************************************************/
	/*  ReportSvcStatus;
	/*  õǰ״̬,䱨SCM;
	/*  ;
	/*  	[IN] dwCurrentStateǰ״̬ SERVICE_STATUS;
	/*  	[IN] dwWin32ExitCodeϵͳطĴ;
	/*  	[IN] dwServiceSpecificExitCodeûԶķ;
	/*  	[OUT] dwCheckPoint;
	/*  	[IN/OUT] dwWaitHintĹʱ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	BOOL ReportSvcStatus(DWORD dwCurrentState, DWORD dwWin32ExitCode,DWORD dwServiceSpecificExitCode, DWORD dwCheckPoint, DWORD dwWaitHint)
	{
		BOOL bSuccess; 
		// SERVICE_STATUSṹ,Ա÷״̬;
		g_SvcStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;		// ʾǵķǶռһ̵ķ ;
		g_SvcStatus.dwCurrentState = dwCurrentState;				// ǰ״̬;
		g_SvcStatus.dwWaitHint = dwWaitHint;

		if( dwCurrentState == SERVICE_START_PENDING )  
		{ 
			g_SvcStatus.dwControlsAccepted = 0; // κο֪ͨ; 
		} 
		else 
		{ 
			// ֪ͨ SCM ĸֹ֪ͨͣػͣ;
			g_SvcStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_SHUTDOWN ; //|SERVICE_ACCEPT_PAUSE_CONTINUE;
		} 

		if ( (dwCurrentState == SERVICE_RUNNING ) || ( dwCurrentState == SERVICE_STOPPED ) )
			g_SvcStatus.dwCheckPoint = 0;
		else
			g_SvcStatus.dwCheckPoint = dwCheckPoint++;

		// dwServiceSpecificExitCodeֹ񲢱˳ϸʱá
		// ʼʱ˳ֵΪ 0; 
		if(dwServiceSpecificExitCode == 0) 
		{ 
			g_SvcStatus.dwWin32ExitCode = dwWin32ExitCode; 
		} 
		else 
		{ 
			g_SvcStatus.dwWin32ExitCode = ERROR_SERVICE_SPECIFIC_ERROR; //ûԶ;
		} 
		g_SvcStatus.dwServiceSpecificExitCode = dwServiceSpecificExitCode; 

		//únServiceStatus,SCM״̬,0ʾɹ,0ʾʧ;
		bSuccess = SetServiceStatus( g_SvcStatusHandle,&g_SvcStatus);  
		if( !bSuccess )
		{ 
			SvcReportEvent(_T("Set Service Status failed (%d) "), GetLastError());
			KillService(); 
			return FALSE;  
		} 
		else 
			return TRUE;
	}

	// ;
	void KillService()
	{
		//LOG4C((LOG_NOTICE,"KillService."));
		SetEvent(g_hCtrlSvc); //ɹ򷵻طֵΪ0¼״̬Ϊбǣͷȴ̡߳¼ֹģ¼бֱResetEvent½ͷỴ̂߳¼Զģ¼бǣֱһ̱߳ͷţϵͳ¼״̬Ϊޱǡû߳ڵȴ¼бǣֱһ̱߳ͷš
		//ReportStatusToSCMgr(SERVICE_STOPPED,NO_ERROR,0,0,0); 
	}


	/************************************************************************/
	/*  ;
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void SvcReportEvent(IN LPCTSTR pFormat, ...)
	{
		TCHAR    szReport[MAX_PATH] = {0};
		HANDLE   hEventSource;
		LPCTSTR  lpszStrings[2];
		va_list  pArg = NULL;

		va_start(pArg, pFormat);
		StringCchVPrintf(szReport, MAX_PATH, pFormat, pArg);
		va_end(pArg);

		hEventSource = RegisterEventSource(NULL, g_szSvcName);
		if (hEventSource != NULL)
		{
			lpszStrings[0] = g_szSvcName;
			lpszStrings[1] = szReport;

			ReportEvent(
				hEventSource,					// ¼־;
				EVENTLOG_INFORMATION_TYPE,		// ¼;
				0,								// ¼;
				0/*SVC_ERROR*/,					// ¼ʶ;
				NULL,							// ްȫʶ;
				2,								// lpszStringsС;
				0,								// ޶;
				lpszStrings,					// ַ;
				NULL							// ޶;
				);

			DeregisterEventSource(hEventSource);
		}
	}

	/************************************************************************/
	/*  StartSvc;
	/*  ;
	/*  ;
	/*  	[IN] lpSvcNameҪ򿪵ķ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void StartSvc(IN LPCTSTR lpSvcName)
	{
		if ( lpSvcName == NULL || lpSvcName[0] == _T('\0'))
		{
			_tprintf_s(_T("Ҫķ\n"));
			return;
		}

		SC_HANDLE schSCM;
		SC_HANDLE schService;
		SERVICE_STATUS_PROCESS ssStatus; 
		DWORD dwOldCheckPoint; 
		DWORD dwStartTickCount;
		DWORD dwWaitTime;
		DWORD dwBytesNeeded;

		// 򿪷; 
		schSCM = OpenSCManager( 
			NULL,                    // NULLʾҪؼ;
			NULL,                    // NULlʾݿ; 
			SC_MANAGER_ALL_ACCESS);  // ȫȨ; 

		if (NULL == schSCM) 
		{
			_tprintf_s(_T("OpenSCManager failed (%d)\n"), GetLastError());
			return;
		}

		// ȡ;
		schService = OpenService( 
			schSCM,					// SCMݿ; 
			lpSvcName,				// ;
			SERVICE_ALL_ACCESS);	// ȫȨ;

		if (schService == NULL)
		{ 
			_tprintf_s(_T("OpenService failed (%d)\n"), GetLastError()); 
			CloseServiceHandle(schSCM);
			return;
		}    

		// ǰ,״̬Էֹͣ״̬;
		if (!QueryServiceStatusEx( 
			schService,                     // ; 
			SC_STATUS_PROCESS_INFO,         // Ҫѯķ״̬;
			(LPBYTE) &ssStatus,             // ״ַ̬;
			sizeof(SERVICE_STATUS_PROCESS), // ṹС;
			&dwBytesNeeded ) )              // size needed if buffer is too small
		{
			_tprintf_s(_T("QueryServiceStatusEx failed (%d)\n"), GetLastError());
			CloseServiceHandle(schService); 
			CloseServiceHandle(schSCM);
			return; 
		}

		// Check if the service is already running. It would be possible 
		// to stop the service here, but for simplicity this example just returns. 
		// Ѿ,;ֹͣ,,ֻ;
		if(ssStatus.dwCurrentState != SERVICE_STOPPED && ssStatus.dwCurrentState != SERVICE_STOP_PENDING)
		{
			_tprintf_s(_T("Cannot start the service because it is already running\n"));
			CloseServiceHandle(schService); 
			CloseServiceHandle(schSCM);
			return; 
		}

		// Save the tick count and initial checkpoint.
		// ֵּʼ;
		dwStartTickCount = GetTickCount();
		dwOldCheckPoint = ssStatus.dwCheckPoint;

		// Wait for the service to stop before attempting to start it.
		// ڳǰ,ȴֹͣ;
		while (ssStatus.dwCurrentState == SERVICE_STOP_PENDING)
		{
			// Do not wait longer than the wait hint. A good interval is 
			// one-tenth of the wait hint but not less than 1 second  
			// and not more than 10 seconds. 

			dwWaitTime = ssStatus.dwWaitHint / 10;

			if( dwWaitTime < 1000 )
				dwWaitTime = 1000;
			else if ( dwWaitTime > 10000 )
				dwWaitTime = 10000;

			Sleep( dwWaitTime );

			// Check the status until the service is no longer stop pending. 
			// ״ֱֹ̬ͣȴ;
			if (!QueryServiceStatusEx( 
				schService,                     // handle to service 
				SC_STATUS_PROCESS_INFO,         // information level
				(LPBYTE) &ssStatus,             // address of structure
				sizeof(SERVICE_STATUS_PROCESS), // size of structure
				&dwBytesNeeded ) )              // size needed if buffer is too small
			{
				_tprintf_s(_T("QueryServiceStatusEx failed (%d)\n"), GetLastError());
				CloseServiceHandle(schService); 
				CloseServiceHandle(schSCM);
				return; 
			}

			if ( ssStatus.dwCheckPoint > dwOldCheckPoint )
			{
				// Continue to wait and check.
				// ȴ;
				dwStartTickCount = GetTickCount();
				dwOldCheckPoint = ssStatus.dwCheckPoint;
			}
			else
			{
				if(GetTickCount()-dwStartTickCount > ssStatus.dwWaitHint)
				{
					_tprintf_s(_T("Timeout waiting for service to stop\n"));
					CloseServiceHandle(schService); 
					CloseServiceHandle(schSCM);
					return; 
				}
			}
		}

		// Attempt to start the service.
		// ;
		if (!StartService(
			schService,  // handle to service 
			0,           // number of arguments 
			NULL) )      // no arguments 
		{
			_tprintf_s(_T("StartService failed (%d)\n"), GetLastError());
			CloseServiceHandle(schService); 
			CloseServiceHandle(schSCM);
			return; 
		}
		else printf("Service start pending...\n"); 

		// Check the status until the service is no longer start pending. 
		// ״ֱ̬;
		if (!QueryServiceStatusEx( 
			schService,                     // handle to service 
			SC_STATUS_PROCESS_INFO,         // info level
			(LPBYTE) &ssStatus,             // address of structure
			sizeof(SERVICE_STATUS_PROCESS), // size of structure
			&dwBytesNeeded ) )              // if buffer too small
		{
			_tprintf_s(_T("QueryServiceStatusEx failed (%d)\n"), GetLastError());
			CloseServiceHandle(schService); 
			CloseServiceHandle(schSCM);
			return; 
		}

		// Save the tick count and initial checkpoint.
		dwStartTickCount = GetTickCount();
		dwOldCheckPoint = ssStatus.dwCheckPoint;

		while (ssStatus.dwCurrentState == SERVICE_START_PENDING) 
		{ 
			// Do not wait longer than the wait hint. A good interval is 
			// one-tenth the wait hint, but no less than 1 second and no 
			// more than 10 seconds. 

			dwWaitTime = ssStatus.dwWaitHint / 10;

			if( dwWaitTime < 1000 )
				dwWaitTime = 1000;
			else if ( dwWaitTime > 10000 )
				dwWaitTime = 10000;

			Sleep( dwWaitTime );

			// Check the status again. 
			if (!QueryServiceStatusEx( 
				schService,             // handle to service 
				SC_STATUS_PROCESS_INFO, // info level
				(LPBYTE) &ssStatus,             // address of structure
				sizeof(SERVICE_STATUS_PROCESS), // size of structure
				&dwBytesNeeded ) )              // if buffer too small
			{
				_tprintf_s(_T("QueryServiceStatusEx failed (%d)\n"), GetLastError());
				break; 
			}

			if ( ssStatus.dwCheckPoint > dwOldCheckPoint )
			{
				// Continue to wait and check.
				dwStartTickCount = GetTickCount();
				dwOldCheckPoint = ssStatus.dwCheckPoint;
			}
			else
			{
				if(GetTickCount()-dwStartTickCount > ssStatus.dwWaitHint)
				{
					// No progress made within the wait hint.
					break;
				}
			}
		} 

		// Determine whether the service is running.
		if (ssStatus.dwCurrentState == SERVICE_RUNNING) 
		{
			_tprintf_s(_T("Service started successfully.\n")); 
		}
		else 
		{ 
			_tprintf_s(_T("Service not started. \n"));
			_tprintf_s(_T("  Current State: %d\n"), ssStatus.dwCurrentState); 
			_tprintf_s(_T("  Exit Code: %d\n"), ssStatus.dwWin32ExitCode); 
			_tprintf_s(_T("  Check Point: %d\n"), ssStatus.dwCheckPoint); 
			_tprintf_s(_T("  Wait Hint: %d\n"), ssStatus.dwWaitHint); 
		} 

		CloseServiceHandle(schService); 
		CloseServiceHandle(schSCM);

	}

	/************************************************************************/
	/*  UpdateSvcDacl;
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void UpdateSvcDacl(IN LPCTSTR lpSvcName)
	{
		if ( lpSvcName == NULL || lpSvcName[0] == _T('\0'))
			return;

		EXPLICIT_ACCESS      ea;
		SECURITY_DESCRIPTOR  sd;
		PSECURITY_DESCRIPTOR psd            = NULL;
		PACL                 pacl           = NULL;
		PACL                 pNewAcl        = NULL;
		BOOL                 bDaclPresent   = FALSE;
		BOOL                 bDaclDefaulted = FALSE;
		DWORD                dwError        = 0;
		DWORD                dwSize         = 0;
		DWORD                dwBytesNeeded  = 0;

		SC_HANDLE schSCManager;
		SC_HANDLE schService;

		// ȡSCMݿľֵ;
		schSCManager = OpenSCManager( 
			NULL,                    // local computer
			NULL,                    // ServicesActive database 
			SC_MANAGER_ALL_ACCESS);  // full access rights 

		if (NULL == schSCManager) 
		{
			_tprintf_s(_T("OpenSCManager failed (%d)\n"), GetLastError());
			return;
		}

		// Get a handle to the service

		schService = OpenService( 
			schSCManager,              // SCManager database 
			lpSvcName,                 // name of service 
			READ_CONTROL | WRITE_DAC); // access

		if (schService == NULL)
		{ 
			_tprintf_s(_T("OpenService failed (%d)\n"), GetLastError()); 
			CloseServiceHandle(schSCManager);
			return;
		}    

		// Get the current security descriptor.
		// ȡǰİȫ;
		if (!QueryServiceObjectSecurity(schService,
			DACL_SECURITY_INFORMATION, 
			&psd,           // using NULL does not work on all versions
			0, 
			&dwBytesNeeded))
		{
			if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
			{
				dwSize = dwBytesNeeded;
				psd = (PSECURITY_DESCRIPTOR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, dwSize);
				if (psd == NULL)
				{
					// Note: HeapAlloc does not support GetLastError.
					_tprintf_s(_T("HeapAlloc failed\n"));
					goto dacl_cleanup;
				}

				if (!QueryServiceObjectSecurity(schService,
					DACL_SECURITY_INFORMATION, psd, dwSize, &dwBytesNeeded))
				{
					_tprintf_s(_T("QueryServiceObjectSecurity failed (%d)\n"), GetLastError());
					goto dacl_cleanup;
				}
			}
			else 
			{
				_tprintf_s(_T("QueryServiceObjectSecurity failed (%d)\n"), GetLastError());
				goto dacl_cleanup;
			}
		}

		// Get the DACL.

		if (!GetSecurityDescriptorDacl(psd, &bDaclPresent, &pacl,
			&bDaclDefaulted))
		{
			_tprintf_s(_T("GetSecurityDescriptorDacl failed(%d)\n"), GetLastError());
			goto dacl_cleanup;
		}

		// Build the ACE.

		BuildExplicitAccessWithName(&ea, TEXT("GUEST"),
			SERVICE_START | SERVICE_STOP | READ_CONTROL | DELETE,
			SET_ACCESS, NO_INHERITANCE);

		dwError = SetEntriesInAcl(1, &ea, pacl, &pNewAcl);
		if (dwError != ERROR_SUCCESS)
		{
			printf("SetEntriesInAcl failed(%d)\n", dwError);
			goto dacl_cleanup;
		}

		// Initialize a new security descriptor.

		if (!InitializeSecurityDescriptor(&sd, 
			SECURITY_DESCRIPTOR_REVISION))
		{
			printf("InitializeSecurityDescriptor failed(%d)\n", GetLastError());
			goto dacl_cleanup;
		}

		// Set the new DACL in the security descriptor.

		if (!SetSecurityDescriptorDacl(&sd, TRUE, pNewAcl, FALSE))
		{
			printf("SetSecurityDescriptorDacl failed(%d)\n", GetLastError());
			goto dacl_cleanup;
		}

		// Set the new DACL for the service object.

		if (!SetServiceObjectSecurity(schService, 
			DACL_SECURITY_INFORMATION, &sd))
		{
			printf("SetServiceObjectSecurity failed(%d)\n", GetLastError());
			goto dacl_cleanup;
		}
		else printf("Service DACL updated successfully\n");

dacl_cleanup:
		CloseServiceHandle(schSCManager);
		CloseServiceHandle(schService);

		if(NULL != pNewAcl)
			LocalFree((HLOCAL)pNewAcl);
		if(NULL != psd)
			HeapFree(GetProcessHeap(), 0, (LPVOID)psd);

	}

	void DoStopSvc(IN LPCTSTR lpSvcName)
	{
		if ( lpSvcName == NULL || lpSvcName[0] == _T('\0'))
		{
			_tprintf_s(_T("ָҪֹͣķЧ\n"));
			return;
		}
		SERVICE_STATUS_PROCESS ssp;
		DWORD dwStartTime = GetTickCount();
		DWORD dwBytesNeeded;
		DWORD dwTimeout = 30000; // 30-second time-out
		DWORD dwWaitTime;

		SC_HANDLE schSCManager;
		SC_HANDLE schService;
		// Get a handle to the SCM database. 

		schSCManager = OpenSCManager( 
			NULL,                    // local computer
			NULL,                    // ServicesActive database 
			SC_MANAGER_ALL_ACCESS);  // full access rights 

		if (NULL == schSCManager) 
		{
			printf("OpenSCManager failed (%d)\n", GetLastError());
			return;
		}

		// Get a handle to the service.

		schService = OpenService( 
			schSCManager,         // SCM database 
			lpSvcName,            // name of service 
			SERVICE_STOP | 
			SERVICE_QUERY_STATUS | 
			SERVICE_ENUMERATE_DEPENDENTS);  

		if (schService == NULL)
		{ 
			printf("OpenService failed (%d)\n", GetLastError()); 
			CloseServiceHandle(schSCManager);
			return;
		}    

		// Make sure the service is not already stopped.

		if ( !QueryServiceStatusEx( 
			schService, 
			SC_STATUS_PROCESS_INFO,
			(LPBYTE)&ssp, 
			sizeof(SERVICE_STATUS_PROCESS),
			&dwBytesNeeded ) )
		{
			printf("QueryServiceStatusEx failed (%d)\n", GetLastError()); 
			goto stop_cleanup;
		}

		if ( ssp.dwCurrentState == SERVICE_STOPPED )
		{
			printf("Service is already stopped.\n");
			goto stop_cleanup;
		}

		// If a stop is pending, wait for it.

		while ( ssp.dwCurrentState == SERVICE_STOP_PENDING ) 
		{
			printf("Service stop pending...\n");

			// Do not wait longer than the wait hint. A good interval is 
			// one-tenth of the wait hint but not less than 1 second  
			// and not more than 10 seconds. 

			dwWaitTime = ssp.dwWaitHint / 10;

			if( dwWaitTime < 1000 )
				dwWaitTime = 1000;
			else if ( dwWaitTime > 10000 )
				dwWaitTime = 10000;

			Sleep( dwWaitTime );

			if ( !QueryServiceStatusEx( 
				schService, 
				SC_STATUS_PROCESS_INFO,
				(LPBYTE)&ssp, 
				sizeof(SERVICE_STATUS_PROCESS),
				&dwBytesNeeded ) )
			{
				printf("QueryServiceStatusEx failed (%d)\n", GetLastError()); 
				goto stop_cleanup;
			}

			if ( ssp.dwCurrentState == SERVICE_STOPPED )
			{
				printf("Service stopped successfully.\n");
				goto stop_cleanup;
			}

			if ( GetTickCount() - dwStartTime > dwTimeout )
			{
				printf("Service stop timed out.\n");
				goto stop_cleanup;
			}
		}

		// If the service is running, dependencies must be stopped first.

		StopDependentServices();

		// Send a stop code to the service.

		if ( !ControlService( 
			schService, 
			SERVICE_CONTROL_STOP, 
			(LPSERVICE_STATUS) &ssp ) )
		{
			printf( "ControlService failed (%d)\n", GetLastError() );
			goto stop_cleanup;
		}

		// Wait for the service to stop.

		while ( ssp.dwCurrentState != SERVICE_STOPPED ) 
		{
			Sleep( ssp.dwWaitHint );
			if ( !QueryServiceStatusEx( 
				schService, 
				SC_STATUS_PROCESS_INFO,
				(LPBYTE)&ssp, 
				sizeof(SERVICE_STATUS_PROCESS),
				&dwBytesNeeded ) )
			{
				printf( "QueryServiceStatusEx failed (%d)\n", GetLastError() );
				goto stop_cleanup;
			}

			if ( ssp.dwCurrentState == SERVICE_STOPPED )
				break;

			if ( GetTickCount() - dwStartTime > dwTimeout )
			{
				printf( "Wait timed out\n" );
				goto stop_cleanup;
			}
		}
		printf("Service stopped successfully\n");

stop_cleanup:
		CloseServiceHandle(schService); 
		CloseServiceHandle(schSCManager);

	}

	BOOL StopDependentServices()
	{
		DWORD i;
		DWORD dwBytesNeeded;
		DWORD dwCount;

		LPENUM_SERVICE_STATUS   lpDependencies = NULL;
		ENUM_SERVICE_STATUS     ess;
		SC_HANDLE               hDepService;
		SERVICE_STATUS_PROCESS  ssp;

		DWORD dwStartTime = GetTickCount();
		DWORD dwTimeout = 30000; // 30-second time-out

		SC_HANDLE schSCManager = NULL;
		SC_HANDLE schService = NULL;

		// Pass a zero-length buffer to get the required buffer size.
		if ( EnumDependentServices( schService, SERVICE_ACTIVE, 
			lpDependencies, 0, &dwBytesNeeded, &dwCount ) ) 
		{
			// If the Enum call succeeds, then there are no dependent
			// services, so do nothing.
			return TRUE;
		} 
		else 
		{
			if ( GetLastError() != ERROR_MORE_DATA )
				return FALSE; // Unexpected error

			// Allocate a buffer for the dependencies.
			lpDependencies = (LPENUM_SERVICE_STATUS) HeapAlloc( 
				GetProcessHeap(), HEAP_ZERO_MEMORY, dwBytesNeeded );

			if ( !lpDependencies )
				return FALSE;

			__try {
				// Enumerate the dependencies.
				if ( !EnumDependentServices( schService, SERVICE_ACTIVE, 
					lpDependencies, dwBytesNeeded, &dwBytesNeeded,
					&dwCount ) )
					return FALSE;

				for ( i = 0; i < dwCount; i++ ) 
				{
					ess = *(lpDependencies + i);
					// Open the service.
					hDepService = OpenService( schSCManager, 
						ess.lpServiceName, 
						SERVICE_STOP | SERVICE_QUERY_STATUS );

					if ( !hDepService )
						return FALSE;

					__try {
						// Send a stop code.
						if ( !ControlService( hDepService, 
							SERVICE_CONTROL_STOP,
							(LPSERVICE_STATUS) &ssp ) )
							return FALSE;

						// Wait for the service to stop.
						while ( ssp.dwCurrentState != SERVICE_STOPPED ) 
						{
							Sleep( ssp.dwWaitHint );
							if ( !QueryServiceStatusEx( 
								hDepService, 
								SC_STATUS_PROCESS_INFO,
								(LPBYTE)&ssp, 
								sizeof(SERVICE_STATUS_PROCESS),
								&dwBytesNeeded ) )
								return FALSE;

							if ( ssp.dwCurrentState == SERVICE_STOPPED )
								break;

							if ( GetTickCount() - dwStartTime > dwTimeout )
								return FALSE;
						}
					} 
					__finally 
					{
						// Always release the service handle.
						CloseServiceHandle( hDepService );
					}
				}
			} 
			__finally 
			{
				// Always free the enumeration buffer.
				HeapFree( GetProcessHeap(), 0, lpDependencies );
			}
		} 
		return TRUE;

	}

	/************************************************************************/
	/*  ;
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void DoQuerySvc(IN LPCTSTR lpSvcName)
	{
		if ( lpSvcName == NULL || lpSvcName[0] == _T('\0'))
		{
			_tprintf_s(_T("ҪѯķЧ\n"));
			return;
		}
		SC_HANDLE hSCM;
		SC_HANDLE hSvc;
		LPQUERY_SERVICE_CONFIG lpsc;
		LPSERVICE_DESCRIPTION lpsd;
		DWORD dwBytesNeeded, cbBfuSize, dwError;

		// ȡSCM;
		hSCM = OpenSCManager( NULL, NULL, SC_MANAGER_ALL_ACCESS);
		if ( hSCM == NULL )
		{
			_tprintf_s(_T("OpenSCManager failed (%d)\n"), GetLastError());
			return;
		}

		// ȡ;
		hSvc = OpenService( 
			hSCM, 
			lpSvcName, 
			SERVICE_QUERY_CONFIG			// ҪѯõȨ;
			);
		if ( hSvc == NULL )
		{
			_tprintf_s(_T("OpenService failed (%d)\n"), GetLastError());
			CloseServiceHandle(hSCM);
			return;
		}

		// ȡϢ;
		if ( !QueryServiceConfig( hSvc, NULL, 0, &dwBytesNeeded) )
		{
			dwError = GetLastError();
			if ( ERROR_INSUFFICIENT_BUFFER == dwError )
			{
				cbBfuSize = dwBytesNeeded;
				lpsc = (LPQUERY_SERVICE_CONFIG)LocalAlloc(LMEM_FIXED, cbBfuSize);
			}
			else
			{
				_tprintf_s(_T("QueryServiceConfig failed (%d)\n"), dwError);
				goto cleanup;
			}
		}

		if ( !QueryServiceConfig(hSvc, lpsc, cbBfuSize, &dwBytesNeeded) )
		{
			_tprintf_s(_T("QuerySericeConfig failed (%d)\n"), GetLastError());
			goto cleanup;
		}

		if ( !QueryServiceConfig2( hSvc, SERVICE_CONFIG_DESCRIPTION, NULL, 0, &dwBytesNeeded) )
		{
			dwError = GetLastError();
			if ( ERROR_INSUFFICIENT_BUFFER == dwError )
			{
				cbBfuSize = dwBytesNeeded;
				lpsd = (LPSERVICE_DESCRIPTION)LocalAlloc(LMEM_FIXED, cbBfuSize);
			}
			else
			{
				_tprintf_s(_T("QuerySericeConfig2 failed (%d)\n"), GetLastError());
				goto cleanup;
			}
		}

		if ( !QueryServiceConfig2( hSvc, SERVICE_CONFIG_DESCRIPTION, (LPBYTE)lpsd, cbBfuSize, &dwBytesNeeded) )
		{
			_tprintf_s(_T("QuerySericeConfig2 failed (%d)\n"), GetLastError());
			goto cleanup;
		}

		//////////////////////////////////////////////////////////////////////////
		// ѯɹ,֯ҪصĶ;
		_tprintf(TEXT("%s configuration: \n"), g_szSvcName);
		_tprintf(TEXT("  Type: 0x%x\n"), lpsc->dwServiceType);
		_tprintf(TEXT("  Start Type: 0x%x\n"), lpsc->dwStartType);
		_tprintf(TEXT("  Error Control: 0x%x\n"), lpsc->dwErrorControl);
		_tprintf(TEXT("  Binary path: %s\n"), lpsc->lpBinaryPathName);
		_tprintf(TEXT("  Account: %s\n"), lpsc->lpServiceStartName);

		if (lpsd->lpDescription != NULL && lstrcmp(lpsd->lpDescription, TEXT("")) != 0)
			_tprintf(TEXT("  Description: %s\n"), lpsd->lpDescription);
		if (lpsc->lpLoadOrderGroup != NULL && lstrcmp(lpsc->lpLoadOrderGroup, TEXT("")) != 0)
			_tprintf(TEXT("  Load order group: %s\n"), lpsc->lpLoadOrderGroup);
		if (lpsc->dwTagId != 0)
			_tprintf(TEXT("  Tag ID: %d\n"), lpsc->dwTagId);
		if (lpsc->lpDependencies != NULL && lstrcmp(lpsc->lpDependencies, TEXT("")) != 0)
			_tprintf(TEXT("  Dependencies: %s\n"), lpsc->lpDependencies);

		// ͷԴ;
		LocalFree(lpsc);
		LocalFree(lpsd);

cleanup:
		CloseServiceHandle(hSvc);
		CloseServiceHandle(hSCM);
	}

	/************************************************************************/
	/*  ;
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void DoDisableSvc(IN LPCTSTR lpSvcName)
	{
		if ( lpSvcName == NULL || lpSvcName[0] == _T('\0'))
		{
			_tprintf_s(_T("ҪõķЧ\n"));
			return;
		}
		SC_HANDLE schSCM;
		SC_HANDLE schSvc;

		// SCM;
		schSCM = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		if ( schSCM == NULL )
		{
			_tprintf_s(_T("OpenSCManager failed (%d)\n"), GetLastError());
			return;
		}

		// ȡ;
		schSvc = OpenService(schSCM, lpSvcName, SERVICE_CHANGE_CONFIG );
		if ( schSvc == NULL )
		{
			_tprintf_s(_T("OpenService failed (%d)\n"), GetLastError()); 
			CloseServiceHandle(schSCM);
			return;
		}

		if ( !ChangeServiceConfig(
			schSvc,
			SERVICE_NO_CHANGE, // service type: no change 
			SERVICE_DISABLED,  // service start type 
			SERVICE_NO_CHANGE, // error control: no change 
			NULL,              // binary path: no change 
			NULL,              // load order group: no change 
			NULL,              // tag ID: no change 
			NULL,              // dependencies: no change 
			NULL,              // account name: no change 
			NULL,              // password: no change 
			NULL) )            // display name: no change
		{
			_tprintf_s(_T("ChangeServiceConfig failed (%d)\n"), GetLastError()); 
		}

		CloseServiceHandle(schSvc);
		CloseServiceHandle(schSCM);
	}

	/************************************************************************/
	/*  ;
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void DoEnableSvc(IN LPCTSTR lpSvcName)
	{
		if ( lpSvcName == NULL || lpSvcName[0] == _T('\0'))
		{
			_tprintf_s(_T("ҪõķЧ\n"));
			return;
		}
		SC_HANDLE schSCM;
		SC_HANDLE schSvc;

		// Get a handle to the SCM database. 
		// ȡSCMݿ;
		schSCM = OpenSCManager( 
			NULL,                    // local computer
			NULL,                    // ServicesActive database 
			SC_MANAGER_ALL_ACCESS);  // full access rights 

		if (NULL == schSCM) 
		{
			printf("OpenSCManager failed (%d)\n", GetLastError());
			return;
		}

		// Get a handle to the service.
		// ȡֵ;
		schSvc = OpenService( 
			schSCM,						// SCM database 
			lpSvcName,                // name of service 
			SERVICE_CHANGE_CONFIG);		// need change config access 

		if (schSvc == NULL)
		{ 
			_tprintf_s(_T("OpenService failed (%d)\n"), GetLastError()); 
			CloseServiceHandle(schSCM);
			return;
		}    

		// Change the service start type.
		// ı;
		if (! ChangeServiceConfig( 
			schSvc,					// ; 
			SERVICE_NO_CHANGE,     // service type: no change 
			SERVICE_DEMAND_START,  // service start type 
			SERVICE_NO_CHANGE,     // error control: no change 
			NULL,                  // binary path: no change 
			NULL,                  // load order group: no change 
			NULL,                  // tag ID: no change 
			NULL,                  // dependencies: no change 
			NULL,                  // account name: no change 
			NULL,                  // password: no change 
			NULL) )                // display name: no change
		{
			_tprintf_s(_T("ChangeServiceConfig failed (%d)\n"), GetLastError()); 
		}
		else 
		{
			_tprintf_s(_T("Service enabled successfully.\n")); 
		}

		CloseServiceHandle(schSvc); 
		CloseServiceHandle(schSCM);
	}

	/************************************************************************/
	/*  ;
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void DoUpdateSvcDesc(IN LPCTSTR lpSvcName)
	{
		if ( lpSvcName == NULL || lpSvcName[0] == _T('\0'))
		{
			_tprintf_s(_T("ҪķЧ\n"));
			return;
		}
		SC_HANDLE schSCM;
		SC_HANDLE schSvc;
		SERVICE_DESCRIPTION sd;
		LPTSTR szDesc = TEXT("This is a test description");

		// Get a handle to the SCM database. 
		// ȡSCMݿ;
		schSCM = OpenSCManager( 
			NULL,                    // NULLʾؼ;
			NULL,                    // NULLʾServicesActive database 
			SC_MANAGER_ALL_ACCESS);  // full access rights 

		if (NULL == schSCM) 
		{
			_tprintf_s(_T("OpenSCManager failed (%d)\n"), GetLastError());
			return;
		}

		// Get a handle to the service.
		// ȡֵ;
		schSvc = OpenService( 
			schSCM,						// SCM ݿ; 
			lpSvcName,                // ; 
			SERVICE_CHANGE_CONFIG);     // need change config access 

		if (schSvc == NULL)
		{ 
			_tprintf_s(_T("OpenService failed (%d)\n"), GetLastError()); 
			CloseServiceHandle(schSCM);
			return;
		}    

		// Change the service description.
		// ı;
		sd.lpDescription = szDesc;

		if( !ChangeServiceConfig2(
			schSvc,						// ;
			SERVICE_CONFIG_DESCRIPTION, // Ҫı: description;
			&sd) )                      // ;
		{
			_tprintf_s(_T("ChangeServiceConfig2 failed\n"));
		}
		else 
		{
			_tprintf_s(_T("Service description updated successfully.\n"));
		}

		CloseServiceHandle(schSvc); 
		CloseServiceHandle(schSCM);

	}

	/************************************************************************/
	/*  ;
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void DoDeleteSvc(IN LPCTSTR lpSvcName)
	{
		if ( lpSvcName == NULL || lpSvcName[0] == _T('\0'))
		{
			_tprintf_s(_T("ҪɾķЧ\n"));
			return;
		}
		SC_HANDLE schSCM;
		SC_HANDLE schSvc;
		SERVICE_STATUS ssStatus; 

		// 򿪷;
		schSCM = OpenSCManager( 
			NULL,                    // NULLʾؼ;
			NULL,                    // NULLʾServicesActive database 
			SC_MANAGER_ALL_ACCESS);  // full access rights 

		if (NULL == schSCM) 
		{
			_tprintf_s(_T("OpenSCManager failed (%d)\n"), GetLastError());
			return;
		}

		// 򿪷;
		schSvc = OpenService( 
			schSCM,								// SCM database 
			lpSvcName,							// name of service 
			SERVICE_STOP|DELETE					// need delete access 
			);				

		if (schSvc == NULL)
		{ 
			_tprintf_s(_T("OpenService failed (%d)\n"), GetLastError()); 
			CloseServiceHandle(schSCM);
			return;
		}

		// ɾ,Ҫֹͣ;
		if ( !::ControlService(schSvc, SERVICE_CONTROL_STOP, &ssStatus) )
		{
			_tprintf_s(_T("ɾǰֹͣʧ (%d)\n"), GetLastError()); 
		}

		// ɾ;
		if ( !DeleteService(schSvc) ) 
		{
			_tprintf_s(_T("DeleteService failed (%d)\n"), GetLastError()); 
			SvcReportEvent(_T("Service could not be deleted"));
		}
		else
		{
			_tprintf_s(_T("Service deleted successfully\n")); 
		}

		CloseServiceHandle(schSvc); 
		CloseServiceHandle(schSCM);
	}

	/************************************************************************/
	/*  SetCallBack;
	/*  ûص;
	/*  ;
	/*  	[IN] lpStartWorkCallBackʼصָ;
	/*  	[IN] lpEndofWorkCallBackصָ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	void SetCallBack( IN LPVOID lpStartWorkCallBack, IN LPVOID lpEndofWorkCallBack )
	{
		if ( g_lpStartWorkCallBack == NULL )
			g_lpStartWorkCallBack = (WorkEndofCallback)lpStartWorkCallBack;

		if ( g_lpEndofWorkCallBack == NULL )
			g_lpEndofWorkCallBack = (WorkEndofCallback)lpEndofWorkCallBack;
	}

	/************************************************************************/
	/*  StartProcess;
	/*  ڷ,ⲿEXE;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	BOOL StartProcess( IN LPCTSTR lpExePath )
	{
#if 0
		if( !lpExePath || !PathFileExists(lpExePath) )   
		{   
			return FALSE;   
		} 

		HANDLE hToken;   
		if(!GetTokenByName(hToken,_T("EXPLORER.EXE")))   
		{   
			return   FALSE;   
		}  

		STARTUPINFO   si;   
		PROCESS_INFORMATION   pi;   

		ZeroMemory(&si, sizeof(STARTUPINFO));   
		si.cb = sizeof(STARTUPINFO);   
		si.lpDesktop = TEXT("winsta0\\default");   

		BOOL bResult = CreateProcessAsUser(hToken,lpExePath,NULL,NULL,NULL, FALSE,NORMAL_PRIORITY_CLASS,NULL,NULL,&si,&pi); 
		DWORD dwError = GetLastError();// 740,ʾAdmin˺вܴɹ;

		//CreateProcessWithTokenW(hToken, )


		CloseHandle(hToken);   
		if(bResult)   
		{   
			// WriteLogAlways(_T("C:\\serverlog.txt"),_T("CreateProcessAsUser   ok"));
		}   
		else   
		{   
			//WriteLogAlways(_T("C:\\servererrlog.txt"),_T("CreateProcessAsUser   failed"));
		} 
#else
		HANDLE hPtoken = NULL ;   
		GetExplorerToken( &hPtoken ) ;  
		//if(!GetTokenByName(hPtoken,_T("EXPLORER.EXE")))   
		//{   
		//	return   FALSE;   
		//} 
		PROCESS_INFORMATION pi;    
		STARTUPINFOW si = { sizeof(STARTUPINFO),NULL,L"",NULL,0,0,0,0,0,0,0,STARTF_USESHOWWINDOW,0,0,NULL,0,0,0};     
		si.wShowWindow = SW_SHOW;  
		si.lpDesktop = NULL;  
		ZeroMemory( &pi, sizeof(pi) );   

		static HMODULE advapi32_dll = LoadLibraryW(L"advapi32.dll");
		if(!advapi32_dll)
			return FALSE;
		
		/*static F_CreateProcessWithTokenW f_CreateProcessWithTokenW = (F_CreateProcessWithTokenW)(
			GetProcAddress(advapi32_dll,"CreateProcessWithTokenW"));
		if (f_CreateProcessWithTokenW == NULL)
			return ;
*/
		BOOL bResult = CreateProcessWithTokenW(hPtoken, LOGON_WITH_PROFILE, NULL, (LPWSTR)lpExePath, NULL, NULL, NULL, &si,&pi);

		DWORD dwError = GetLastError();
		Sleep(1000);  
		CloseHandle( pi.hProcess );  

		CloseHandle( pi.hThread );
#endif
		return   bResult;   
	}

	/************************************************************************/
	/*  ;
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	BOOL GetTokenByName( IN HANDLE &hToken, IN LPCTSTR lpName)
	{
		if(!lpName)   
		{   
			return FALSE;   
		} 

		BOOL bRet = FALSE;
		HANDLE hProcessSnap = NULL;
		PROCESSENTRY32 pe32 = {0};
		hProcessSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
		if ( hProcessSnap == INVALID_HANDLE_VALUE )
			return FALSE; 

		pe32.dwSize = sizeof(PROCESSENTRY32);     
		if (Process32First(hProcessSnap, &pe32))     
		{       
			do     
			{   
				CString exefile=pe32.szExeFile;
				CString paraname = lpName;
				if(!exefile.CompareNoCase(lpName))
				{   
					HANDLE hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, pe32.th32ProcessID);
					bRet = OpenProcessToken(hProcess,TOKEN_ALL_ACCESS,&hToken);
					CloseHandle( hProcessSnap );
					return bRet;   
				}   
			}     
			while(Process32Next(hProcessSnap,&pe32));     
			bRet = TRUE;     
		}     
		else     
			bRet = FALSE;   

		CloseHandle(hProcessSnap);     
		return bRet; 
	}

	/************************************************************************/
	/*  ;
	/*  ;
	/*  ;
	/*  	[IN] ;
	/*  	[OUT] ;
	/*  	[IN/OUT] ;
	/*  أvoid;
	/*  ע⣺;
	/*  ʾ;
	/*
	/*  ޸ģ;
	/*  ڣ;
	/*  ݣ;
	/************************************************************************/
	// Jeff.Hacker. WINDOWS NT ϵںҪȨ,ܶϵͳи߼;
	BOOL GetDebugPriv()
	{
		// صķָ;
		HANDLE	hToken;
		// صƶȨƵϢ;
		LUID	sedebugnameValue;
		// ȨϢָ(ṹ);
		TOKEN_PRIVILEGES tkp;
		DWORD	dwCurProcId = GetCurrentProcessId();
		// Ҫ޸ķȨ޵Ľ̾;
		HANDLE	hCurProc;
		hCurProc = ::OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwCurProcId);

		if (!::OpenProcessToken(hCurProc, TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
		{
			//ShowSystemErrorInfo(_T("OpenProcessTokenʧ."),GetLastError());
			return FALSE;
		}

		if (!::LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &sedebugnameValue))
		{
			//ShowSystemErrorInfo(_T("LookupPrivilegeValueʧ."),GetLastError());
			CloseHandle(hToken);
			return FALSE;
		}

		tkp.PrivilegeCount = 1;
		tkp.Privileges[0].Luid = sedebugnameValue;
		tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

		if (!::AdjustTokenPrivileges(hToken, FALSE, &tkp, sizeof tkp, NULL, NULL))
		{
			//ShowSystemErrorInfo(_T("AdjustTokenPrivilegesʧ."),GetLastError());
			CloseHandle(hToken);
			return FALSE;
		}

		CloseHandle(hCurProc);
		CloseHandle(hToken);
		return TRUE;
	}

	DWORD GetExplorerToken(OUT HANDLE* phExplorerToken)
	{
		DWORD       dwStatus = ERROR_FILE_NOT_FOUND ;   
		BOOL        bRet = FALSE ;  
		HANDLE      hProcess = NULL ;  
		HANDLE      hProcessSnap = NULL ;  
		TCHAR       szExplorerPath[MAX_PATH] = { 0 };  
		TCHAR       FileName[MAX_PATH] = { 0 };  
		PROCESSENTRY32 pe32 = { 0 } ;  
		__try  
		{  
			GetWindowsDirectory( szExplorerPath , MAX_PATH ) ;  
			_tcscat_s( szExplorerPath , MAX_PATH, _T("\\Explorer.EXE") ) ;    
			hProcessSnap = CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS , 0 ) ;   
			if( hProcessSnap == INVALID_HANDLE_VALUE )    
			{  
				dwStatus = GetLastError() ;   
				__leave ;  
			}   
			pe32.dwSize = sizeof( PROCESSENTRY32 ) ;   
			if( !Process32First( hProcessSnap, &pe32 ))       
			{     
				dwStatus = GetLastError() ;   
				__leave ;   
			}   

			int ii = 0;
			do 
			{      
				hProcess = OpenProcess(PROCESS_ALL_ACCESS/*PROCESS_QUERY_INFORMATION*/,  FALSE, pe32.th32ProcessID ) ;  
				if( NULL != hProcess )          
				{   
					ii++;
					//if ( GetModuleFileNameEx(hProcess , NULL , FileName , MAX_PATH) )  
					//{  
						if( _tcsicmp( pe32.szExeFile , _T("Explorer.EXE") ) == 0 )   
						{                                 
							HANDLE  hToken ;  
							if( OpenProcessToken( hProcess , TOKEN_DUPLICATE  , &hToken ))  
							{       
								HANDLE hNewToken = NULL;
								DuplicateTokenEx(hToken, TOKEN_ALL_ACCESS, NULL, SecurityImpersonation, TokenPrimary, &hNewToken);
								* phExplorerToken = hNewToken ;  
								dwStatus = 0 ; 
								CloseHandle(hToken);
							}  
							break ;  
						}  
					//}  
					CloseHandle ( hProcess ) ;    
					hProcess = NULL ;  
				}  

			} while( Process32Next( hProcessSnap, &pe32 )) ;  
		}  
		__finally   
		{  
			if( NULL != hProcess )  
			{  
				CloseHandle( hProcess ) ;  
			}  
			if( NULL != hProcessSnap )  
			{  
				CloseHandle ( hProcessSnap ) ;  
			}  
		}    
		return dwStatus ;  
	}
};
