/************************************************************************/
/*  Copyright (C), 2016-2020, [IT], Ȩ;
/*  ģ  ;
/*      ;
/*
/*      [V];	
/*      ߣ[IT];
/*      ڣ[12/22/2016];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[IT];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/
#ifndef __FILEHELPING_20150818__
#define __FILEHELPING_20150818__

#pragma once

#include "findfile.h"

#define USE_IMGEXT 0

class filehelper :public findfile
{
public:
	filehelper(void);
	~filehelper(void);

public:
	// ;
	static void random(IN STR_VEC& vtContent, IN BOOL bSort = TRUE);
	// ָ;
	static void split(OUT vector<TString>& vtSplit, IN const TString str, IN const TString strSplit);
	// ݺ׺ļ;
	static void keepdownbyext(IN const TString &keepExt, IN STR_VEC &vtfiles);
	static void keepdownbyext(IN const TString &keepExt, IN const STR_VEC &vtfiles, OUT STR_VEC &vtresult);
	// ݺ׺Ƴļ;
	static void keepoutbyext(IN const TString &removeext, IN STR_VEC &vtfiles);
	static void keepoutbyext(IN const TString &removeext, IN const STR_VEC &vtfiles, OUT STR_VEC &vtresult);
	// ָļ(к׺ģ001.jpg)ļ·;
	void keepdowbyname(IN const STR_VEC &vtnames);
	static void keepdowbyname(IN const STR_VEC &vtnames, IN STR_VEC &vtfiles);
	static void keepdowbyname(IN const STR_VEC &vtnames, IN const STR_VEC &vtfiles, OUT STR_VEC &vt_result);
	// ָļ(޺׺ģ001)ļ·;
	void keepdowbyname_noext(IN const STR_VEC &vtnames);
	static void keepdowbyname_noext(IN const STR_VEC &vtnames, IN STR_VEC &vtfiles);
	static void keepdowbyname_noext(IN const STR_VEC &vtnames, IN const STR_VEC &vtfiles, OUT STR_VEC &vt_result);
	// չ;
	static void subgroupExt(IN const TString &ext1, IN STR_VEC &vt1, IN const TString &ext2, IN STR_VEC &vt2);	

	// к׺ļ(:001.jpg)ļ;
	static void filterbyname(IN STR_VEC &vtfiles, IN const STR_VEC &vtnames);
	void filterbyname(IN const STR_VEC &vtnames);

	// ޺׺ļ(:001)ļ;
	static void filterbyname_noext(IN STR_VEC &vtfiles, IN const STR_VEC &vtnames);
	void filterbyname_noext(IN const STR_VEC &vtnames);

	// ȡļ,׺(:001.jpg);
	inline void getnames(IN STR_VEC &vtfiles, IN STR_VEC &vtnames)
	{
		INT nIndex = 0;
		for ( STR_VEC::iterator it = vtfiles.begin(); it != vtfiles.end(); it++ )
		{
			if ( (nIndex = it->find_last_of(_T('\\'))) != TString::npos )
			{
				vtnames.push_back(it->substr(nIndex+1));
			}
		}
	}

	// ȡļ,׺(:001);
	inline void getnames_noext(IN const STR_VEC &vtfiles, IN STR_VEC &vtnames)
	{
		INT nIndex = 0;
		INT nIndex2 = 0;
		for ( STR_VEC::const_iterator it = vtfiles.begin(); it != vtfiles.end(); it++ )
		{
			if ( (nIndex = it->find_last_of(_T('\\'))) != TString::npos )
			{
				if ( (nIndex2 = it->find_last_of(_T('.'))) != TString::npos)
				{
					if ( nIndex2 > nIndex)
						vtnames.push_back(it->substr(nIndex+1, nIndex2-nIndex));
				}
			}
			else
			{// vtfilesûĿ¼ļ,磺001.jpg;
				if ( (nIndex2 = it->find_last_of(_T('.'))) != TString::npos)
				{
					vtnames.push_back(it->substr(0, nIndex2));
				}
			}
		}
	}
public:
	// ȫ;
	BOOL getall(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN OUT STR_VEC *pvtfiles,							// Ҫҵļȫ;
		IN OUT STR_VEC *pvtnames,							// Ҫҵļ(·,չ);
		IN OUT STR_VEC *pvtfolders							// ҪҵĿ¼;
		);

	// ֻȡǰҪĿ¼ļ,ȡļеļ;
	BOOL getsubfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN STR_VEC *pvtfolders								// ļ;
		);

	BOOL getallsubfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN STR_VEC *pvtfolders								// ļ;
		);

	//////////////////////////////////////////////////////////////////////////
	BOOL getfiles_findin_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC *pvtfiles								// Ҫҵļȫ;
		);

	BOOL getfiles_findout_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN OUT STR_VEC *pvtfiles							// Ҫҵļȫ;
		);

	BOOL getfiles_within_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC *pvtfiles,								// Ҫҵļȫ;
		IN STR_VEC *pvtfolders								// ļ;
		);

	//////////////////////////////////////////////////////////////////////////
	virtual BOOL getfiles_bynames_findin_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC &vtnames,
		IN STR_VEC *pvtfiles								// Ҫҵļȫ;
		);

	virtual BOOL getfiles_bynames_findout_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC &vtnames,
		IN OUT STR_VEC *pvtfiles							// Ҫҵļȫ;
		) ;

	virtual BOOL getfiles_bynames_within_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC &vtnames,
		IN STR_VEC *pvtfiles,								// Ҫҵļȫ;
		IN STR_VEC *pvtfolders								// ļ;
		) ;

	//////////////////////////////////////////////////////////////////////////
	BOOL getnames_findin_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC *pvtnames								// Ҫҵļ(·,չ);
		);

	BOOL getnames_findout_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC *pvtnames								// Ҫҵļ(·,չ);
		);

	BOOL getnames_within_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC *pvtnames,								// Ҫҵļȫ;
		IN STR_VEC *pvtfolders								// ļ;
		);

	//////////////////////////////////////////////////////////////////////////
	BOOL getfilesnames_findin_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC *pvtfiles,								// Ҫҵļȫ;
		IN STR_VEC *pvtnames								// Ҫҵļ(·,չ);
		);

	BOOL getfilesnames_findout_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC *pvtfiles,								// Ҫҵļȫ;
		IN STR_VEC *pvtnames								// Ҫҵļ(·,չ);
		);

	BOOL getfilesnames_within_subfolder(
		IN LPCTSTR lpfolder,								// ҪҵĿ¼;
		IN LPCTSTR lpfindext,								// Ҫҵչ;
		IN STR_VEC *pvtfiles,								// Ҫҵļȫ;
		IN STR_VEC *pvtnames,								// Ҫҵļ(·,չ);
		IN STR_VEC *pvtfolders								// ļ;
		);

public:
	//////////////////////////////////////////////////////////////////////////
	BOOL comparename_findin_names(IN LPCTSTR name);

	// ļԱ,Ƿͬ;
	BOOL comparename_2file(
		IN LPCTSTR file1,									// ļ1(ȫ·);
		IN LPCTSTR file2									// ļ2(ȫ·);
		);

	// ָļ,һļԱ;
	BOOL comparename_findin_names(
		IN LPCTSTR name,									// ļ(·,չ);
		IN STR_VEC& vtnames									// һļ(·,չ);
		);

	// ָļ,һļԱ;
	BOOL comparename_findin_files(
		IN LPCTSTR name,									// ļ(չ);
		IN STR_VEC& vtfiles									// һļ(ȫ·);
		);

	// ָļ,һļжԱ;
	BOOL comparename_findin_folder(
		IN LPCTSTR name,									// ļ(չ);
		IN LPCTSTR folder,									// ļ;
		IN LPCTSTR findext,									// Ҫҵչ;
		IN BOOL bsubfolder									// ǷļڵĿ¼;
		);

	//////////////////////////////////////////////////////////////////////////
	// ָһļ,һļԱ;
	INT comparenames_findin_names(
		IN STR_VEC vtSrcnames,								// ָһԴļ(·,չ);
		IN STR_VEC vtDesnames,								// ָһĿļ(·,չ);
		OUT STR_VEC *pvtIsonym = NULL						// ͬļ;	
		);

	// ָһļ,һļ(ȫ·)Ա;
	INT comparenames_findin_files(
		IN STR_VEC vtnames,									// ָһԴļ(·,չ);
		IN STR_VEC vtfiles,									// ָһĿļ(ȫ·);
		IN LPCTSTR findext,									// Ҫҵչ;
		OUT STR_VEC *pvtIsonym = NULL						// ͬļ;
		);

	// ָһļ,һļжԱ;
	INT comparenames_findin_folder(
		IN STR_VEC vtnames,									// ָһԴļ(·,չ);
		IN LPCTSTR folder,									// ļ;
		IN BOOL bsubfolder,									// ǷļڵĿ¼;
		IN LPCTSTR findext,									// Ҫҵչ;
		OUT STR_VEC *pvtIsonym = NULL						// ͬļ;
		);

	//////////////////////////////////////////////////////////////////////////
	// ָһļ,һļԱ;
	BOOL comparefile_findin_names(
		IN LPCTSTR file,									// ļ1(ȫ·);
		IN STR_VEC& vtnames									// ָһļ(·,չ)
		);

	// ָһļ,һļԱ;
	BOOL comparefile_findin_files(
		IN LPCTSTR file,									// ļ(ȫ·);
		IN STR_VEC& vtfiles,									// ָһļ(ȫ·)
		IN LPCTSTR findext									// Ҫҵչ;
		);

	// ָһļ,һļжԱ;
	BOOL comparefile_findin_folder(
		IN LPCTSTR file,									// ļ(ȫ·);
		IN LPCTSTR folder,									// ļ;
		IN BOOL bsubfolder,									// Ƿļ;
		IN LPCTSTR findext									// Ҫҵչ;
		);

	//////////////////////////////////////////////////////////////////////////
	// ָһļ,һļԱ;
	INT comparefiles_findin_files(
		IN STR_VEC &vtfiles1,								// ָһԴļ;
		IN STR_VEC &vtfiles2,								// ָһĿļ;
		IN LPCTSTR findext,									// Ҫҵչ;
		OUT STR_VEC *pvtIsonym = NULL						// ͬļ;
		);

	// ָһļ,һļжԱ;
	INT comparefiles_findin_folder(
		IN STR_VEC &vtfiles,								// ָһԴļ;
		IN LPCTSTR folder,									// ָļ;
		IN BOOL bsubfolder,									// Ƿļ;
		IN LPCTSTR findext,									// Ҫҵչ;
		OUT STR_VEC *pvtIsonym = NULL						// ͬļ;
		);

	// ļҶԱ(ļжԱ)
	INT comparefolderself(
		IN LPCTSTR folder,									// ָļ;
		IN LPCTSTR findext,									// Ҫҵչ;
		OUT STR_VEC *pvtIsonym = NULL						// ͬļ;
		);

	// ָһļ,һļжԱ;
	INT comparefolder_findin_folder(
		IN LPCTSTR folder1,									// ָԴļ;
		IN LPCTSTR folder2,									// ָĿļ;
		IN BOOL bsubfolder,									// Ƿļ;
		IN LPCTSTR findext,									// Ҫҵչ;
		OUT STR_VEC *pvtIsonym = NULL						// ͬļ;
		);

	public:
		INT copyfolder(IN LPCTSTR from, IN LPCTSTR to);
};

#endif