/************************************************************************/
/*  Copyright (C), 2016-2020, [IT], Ȩ;
/*  ģ  ;
/*      ǰĿݿʵ;
/*
/*      [V];	
/*      ߣ[IT];
/*      ڣ[11/13/2016];
/*
/*
/*  ע    ⣺;
/*
/*  ޸ļ¼[IT];
/*  ޸ڣ;
/*  ޸İ汾;
/*  ޸ݣ;
/************************************************************************/
#ifndef __DATA_IMPL__
#define __DATA_IMPL__

#pragma once

#include <vector>
#include "TableInfo.h"

class CDataImpl
{
public:
	CDataImpl(void);
	virtual ~CDataImpl(void);

	// ˽б;
private:
	sqlite3		*m_psqlite3;

	// û;
public:
	BOOL Open();
	void Close();

	// begin;
	int TransactionBegin()
	{
		char* psqlite_error = NULL;
		INT nRet = sqlite3_exec(m_psqlite3, "begin;", 0, 0, &psqlite_error);
		if ( nRet != SQLITE_OK)
		{
			if ( psqlite_error ) 
			{ 
				sqlite3_free(psqlite_error); 
				psqlite_error = NULL;
			}
			return nRet;
		}

		return SQLITE_OK;
	}

	// commit;
	int TransactionCommit()
	{
		char* psqlite_error = NULL;
		INT nRet = sqlite3_exec(m_psqlite3, "commit;", 0, 0, &psqlite_error);
		if ( nRet != SQLITE_OK)
		{
			if ( psqlite_error ) 
			{ 
				sqlite3_free(psqlite_error); 
				psqlite_error = NULL;
			}
			return nRet;
		}
		return SQLITE_OK;
	}

	// ִ;
	BOOL ExecteSQL(IN LPCSTR lpSQL);
	// ѯǷ;
	BOOL QueryTable(std::string table);

	// ݶŲѯϢ;//زѯ;
	INT QueryMidInfo(std::string order, STMid &data);
	INT QueryKeyInfo(std::string sn, STKeys &data);
	INT QueryUnReportKeyInfo(std::vector<STKeys> &vtdata);
	INT QueryLogInfo(std::string sn, STLog &data);
	INT QueryUnReportLogInfo(std::vector<STLog> &vtdata);
	// ѯдɹɹϱд;
	INT QueryBidInfo(std::string order, BidInfo &binfo);

	// midϢ;
	INT InsertMidInfo(STMid &data);
	// sn keyϢ;
	INT InsertKeyInfo(STKeys &data);
	// log;
	INT InsertLogInfo(STLog &data);

	// keys;
	INT BatchInsertKeyInfo(std::vector<STKeys> &vtdata);

	// MID;
	BOOL UpdateMidInfo(STMid &data);
	// ״̬;ɹʱʱ䣩
	BOOL UpdateDownloadStatus(std::string order, int status, std::string des = "" /*ʧ*/);
	// ³д״̬;
	BOOL UpdateKeyCopyStatus(std::string sn);
	// ϱ״̬;
	BOOL UpdateKeyReportStatus(std::string sn);
	BOOL BatchUpdateKeyReportStatus(std::vector<STKeys> &vtKeys);
	// ־ϱ״̬;
	BOOL UpdateLogReportStatus(std::string sn, std::string type);

	// ɾ;
	BOOL RemoveBidData(std::string order);
};

#endif